ConsRS = {}
ConsRS.Name = UnitName("player")
ConsRS.Realm = string.gsub(GetRealmName(), " ", "")
ConsRS.TimerACtive = 0
ConsRS.FrameCounter = 0
ConsRS.DeleteShow = 0
ConsRS.SelectedRaid = 0
ConsRS.AlphaFadeOut = 1
ConsRS.Faction = UnitFactionGroup("player")
ConsRS.RaidFramePos = {}
ConsRS.RaidFramePos["g1"] = {}
ConsRS.RaidFramePos["g2"] = {}
ConsRS.RaidFramePos["g3"] = {}
ConsRS.RaidFramePos["g4"] = {}
ConsRS.RaidFramePos["g5"] = {}
ConsRS.RaidFramePos["g6"] = {}
ConsRS.RaidFramePos["g7"] = {}
ConsRS.RaidFramePos["g8"] = {}
ConsRS.DubbleClickCD = 0
ConsRS.ClassColors = {
	[1] = {
		[1] = 1.00,
		[2] = 0.49,
		[3] = 0.04,
	},
	[2] = {
		[1] = 0.67,
		[2] = 0.83,
		[3] = 0.45,
	},
	[3] = {
		[1] = 0.25,
		[2] = 0.78,
		[3] = 0.92,
	},
	[4] = {
		[1] = 0.96,
		[2] = 0.55,
		[3] = 0.73,
	},
	[5] = {
		[1] = 1.00,
		[2] = 1.00,
		[3] = 1.00,
	},
	[6] = {
		[1] = 1.00,
		[2] = 0.96,
		[3] = 0.41,
	},
	[7] = {
		[1] = 0.53,
		[2] = 0.53,
		[3] = 0.93,
	},
	[8] = {
		[1] = 0.78,
		[2] = 0.61,
		[3] = 0.43,
	},
}


function ConsRS.MakeFrames()
	ConsRS.Frame = CreateFrame("frame", "ConsRSMainFrame", UIParent)
	ConsRS.Frame:SetWidth(1)
	ConsRS.Frame:SetHeight(1)
	ConsRS.Frame:SetMovable(true)
	ConsRS.Frame:EnableMouse(true)
	ConsRS.Frame:SetFrameStrata("LOW")
	ConsRS.Frame:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
	ConsRS.Frame.F = CreateFrame("frame", "ConsRSMainFrame2", ConsRS.Frame)
	ConsRS.Frame.F:SetWidth(55)
	ConsRS.Frame.F:SetHeight(25)
	ConsRS.Frame.F:SetMovable(true)
	ConsRS.Frame.F:EnableMouse(true)
	ConsRS.Frame.F:SetFrameStrata("LOW")
	ConsRS.Frame.F:SetPoint("TOPLEFT", ConsRS.Frame, "TOPLEFT", 10, 0)
	ConsRS.Frame.F:SetBackdrop( { 
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", 
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = true, tileSize = 10, edgeSize = 10, insets = { left = 2, right = 2, top = 2, bottom = 2 }
	});
	ConsRS.Frame.F:SetScript("OnMouseDown", function(self, button)
			if button == "RightButton" then
				ConsRS.Frame:StartMoving();
				ConsRS.Frame.isMoving = true;
			else
				if (ConsRS.Frame3:IsShown()) then
					ConsRS.Frame3:Hide()
				else
					ConsRS.Frame31:Hide()
					ConsRS.Frame3:Show()
					ConsRS.Frame3.editFrame:SetFocus()
				end
			end
	end)
	ConsRS.Frame.F:SetScript("OnMouseUp", function(self, button)
		if button == "RightButton" and ConsRS.Frame.isMoving then
			ConsRS.Frame:StopMovingOrSizing();
			ConsRS.Frame.isMoving = false;
			ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["left"] = ConsRS.Frame:GetLeft()
			ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["top"] = ConsRS.Frame:GetTop() - GetScreenHeight()
			ConsRS.Frame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["left"], ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["top"])
		end
	end)
	ConsRS.Frame.F:SetScript("OnHide", function(self)
		if ( ConsRS.Frame.isMoving ) then
			ConsRS.Frame:StopMovingOrSizing();
			ConsRS.Frame.isMoving = false;
			ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["left"] = ConsRS.Frame:GetLeft()
			ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["top"] = ConsRS.Frame:GetTop() - GetScreenHeight()
			ConsRS.Frame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["left"], ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["top"])
		end
	end)
	ConsRS.Frame.F:SetScale(0.7)
	ConsRS.Frame.F:Hide()
	ConsRS.Frame.F.FS1 = ConsRS.Frame.F:CreateFontString("ConsRS_Frame_FF21S","ARTWORK", "ChatFontNormal")
	ConsRS.Frame.F.FS1:SetParent(ConsRS.Frame.F)
	ConsRS.Frame.F.FS1:SetPoint("LEFT",ConsRS.Frame.F,"LEFT",0,0)
	ConsRS.Frame.F.FS1:SetWidth(55)
	ConsRS.Frame.F.FS1:SetHeight(38)
	ConsRS.Frame.F.FS1:SetJustifyH("CENTER")
	ConsRS.Frame.F.FS1:SetFontObject("GameFontNormalLarge")
	ConsRS.Frame.F.FS1:SetText("Save")
	ConsRS.Frame.F.FS1:SetTextColor(1, 1, 0)
	ConsRS.Frame.F2 = CreateFrame("frame", "ConsRSMainFrame3", ConsRS.Frame.F)
	ConsRS.Frame.F2:SetWidth(65)
	ConsRS.Frame.F2:SetHeight(25)
	ConsRS.Frame.F2:SetMovable(true)
	ConsRS.Frame.F2:EnableMouse(true)
	ConsRS.Frame.F2:SetFrameStrata("LOW")
	ConsRS.Frame.F2:SetPoint("TOPLEFT", ConsRS.Frame.F, "TOPRIGHT", 0, 0)
	ConsRS.Frame.F2:SetBackdrop( { 
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", 
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = true, tileSize = 10, edgeSize = 10, insets = { left = 2, right = 2, top = 2, bottom = 2 }
	});
	ConsRS.Frame.F2:SetScript("OnMouseDown", function(self, button)
			if button == "RightButton" then
				ConsRS.Frame:StartMoving();
				ConsRS.Frame.isMoving = true;
			else
				ConsRS.Frame:StopMovingOrSizing();
				ConsRS.Frame.isMoving = false;
				ConsRS.ShowDelete()
				ConsRS.Fx3:Hide()
				ConsRS.FG1:Hide()
			end
	end)
	ConsRS.Frame.F2:SetScript("OnMouseUp", function(self, button)
		if button == "RightButton" and ConsRS.Frame.isMoving then
			ConsRS.Frame:StopMovingOrSizing();
			ConsRS.Frame.isMoving = false;
			ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["left"] = ConsRS.Frame:GetLeft()
			ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["top"] = ConsRS.Frame:GetTop() - GetScreenHeight()
			ConsRS.Frame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["left"], ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["top"])
		end
	end)
	ConsRS.Frame.F2:SetScript("OnHide", function(self)
		if ( ConsRS.Frame.isMoving ) then
			ConsRS.Frame:StopMovingOrSizing();
			ConsRS.Frame.isMoving = false;
			ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["left"] = ConsRS.Frame:GetLeft()
			ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["top"] = ConsRS.Frame:GetTop() - GetScreenHeight()
			ConsRS.Frame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["left"], ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["top"])
		end
	end)
	ConsRS.Frame.F2.FS1 = ConsRS.Frame.F2:CreateFontString("ConsRS_Frame_FF1S","ARTWORK", "ChatFontNormal")
	ConsRS.Frame.F2.FS1:SetParent(ConsRS.Frame.F2)
	ConsRS.Frame.F2.FS1:SetPoint("LEFT",ConsRS.Frame.F2,"LEFT",0,0)
	ConsRS.Frame.F2.FS1:SetWidth(65)
	ConsRS.Frame.F2.FS1:SetHeight(38)
	ConsRS.Frame.F2.FS1:SetJustifyH("CENTER")
	ConsRS.Frame.F2.FS1:SetFontObject("GameFontNormalLarge")
	ConsRS.Frame.F2.FS1:SetText("Delete")
	ConsRS.Frame.F2.FS1:SetTextColor(1, 1, 0)
	
	
	
	ConsRS.Frame.F7 = CreateFrame("frame", "ConsRSMainFrame7", ConsRS.Frame.F)
	ConsRS.Frame.F7:SetWidth(65)
	ConsRS.Frame.F7:SetHeight(25)
	ConsRS.Frame.F7:SetMovable(true)
	ConsRS.Frame.F7:EnableMouse(true)
	ConsRS.Frame.F7:SetFrameStrata("LOW")
	ConsRS.Frame.F7:SetPoint("TOPRIGHT", ConsRS.Frame.F, "TOPLEFT", 0, 0)
	ConsRS.Frame.F7:SetBackdrop( { 
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", 
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = true, tileSize = 10, edgeSize = 10, insets = { left = 2, right = 2, top = 2, bottom = 2 }
	});
	ConsRS.Frame.F7:SetScript("OnMouseDown", function(self, button)
			if button == "RightButton" then
				ConsRS.Frame:StartMoving();
				ConsRS.Frame.isMoving = true;
			else
				ConsRS.Frame:StopMovingOrSizing();
				ConsRS.Frame.isMoving = false;
				if (ConsRS.Frame31:IsShown()) then
					ConsRS.Frame31:Hide()
				else
					ConsRS.Frame3:Hide()
					ConsRS.Frame31:Show()
					ConsRS.Frame31.editFrame:SetFocus()
				end
				ConsRS.Fx3:Hide()
				ConsRS.FG1:Hide()
			end
	end)
	ConsRS.Frame.F7:SetScript("OnMouseUp", function(self, button)
		if button == "RightButton" and ConsRS.Frame.isMoving then
			ConsRS.Frame:StopMovingOrSizing();
			ConsRS.Frame.isMoving = false;
			ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["left"] = ConsRS.Frame:GetLeft()
			ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["top"] = ConsRS.Frame:GetTop() - GetScreenHeight()
			ConsRS.Frame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["left"], ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["top"])
		end
	end)
	ConsRS.Frame.F7:SetScript("OnHide", function(self)
		if ( ConsRS.Frame.isMoving ) then
			ConsRS.Frame:StopMovingOrSizing();
			ConsRS.Frame.isMoving = false;
			ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["left"] = ConsRS.Frame:GetLeft()
			ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["top"] = ConsRS.Frame:GetTop() - GetScreenHeight()
			ConsRS.Frame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["left"], ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["top"])
		end
	end)
	ConsRS.Frame.F7.FS1 = ConsRS.Frame.F7:CreateFontString("ConsRS_Frame_F7F1S","ARTWORK", "ChatFontNormal")
	ConsRS.Frame.F7.FS1:SetParent(ConsRS.Frame.F7)
	ConsRS.Frame.F7.FS1:SetPoint("LEFT",ConsRS.Frame.F7,"LEFT",0,0)
	ConsRS.Frame.F7.FS1:SetWidth(65)
	ConsRS.Frame.F7.FS1:SetHeight(38)
	ConsRS.Frame.F7.FS1:SetJustifyH("CENTER")
	ConsRS.Frame.F7.FS1:SetFontObject("GameFontNormalLarge")
	ConsRS.Frame.F7.FS1:SetText("Make")
	ConsRS.Frame.F7.FS1:SetTextColor(1, 1, 0)
	ConsRS.Frame.FFX = CreateFrame("frame", "ConsRSMainFrame3", ConsRS.Frame)
	ConsRS.Frame.FFX:SetWidth(60)
	ConsRS.Frame.FFX:SetHeight(20)
	ConsRS.Frame.FFX:SetScale(0.7)
	ConsRS.Frame.FFX:SetMovable(true)
	ConsRS.Frame.FFX:EnableMouse(true)
	ConsRS.Frame.FFX:SetFrameStrata("LOW")
	ConsRS.Frame.FFX:SetPoint("TOPLEFT", ConsRS.Frame.F, "TOPLEFT", 0, 20)
	ConsRS.Frame.FFX:SetBackdrop( { 
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", 
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = true, tileSize = 10, edgeSize = 10, insets = { left = 2, right = 2, top = 2, bottom = 2 }
	});
	ConsRS.Frame:Hide()
	ConsRS.Frame.FFX:SetScript("OnMouseDown", function(self, button)
			if button == "RightButton" then
				ConsRS.Frame:StartMoving();
				ConsRS.Frame.isMoving = true;
			else
				ConsRS.Frame:StopMovingOrSizing();
				ConsRS.Frame.isMoving = false;
				if (ConsRS.Frame.F:IsShown()) then
					ConsRS.Frame.F:Hide()
				else
					ConsRS.Frame.F:Show()
				end
				ConsRS.Fx3:Hide()
				ConsRS.FG1:Hide()
			end
	end)
	ConsRS.Frame.FFX:SetScript("OnMouseUp", function(self, button)
		if button == "RightButton" and ConsRS.Frame.isMoving then
			ConsRS.Frame:StopMovingOrSizing();
			ConsRS.Frame.isMoving = false;
			ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["left"] = ConsRS.Frame:GetLeft()
			ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["top"] = ConsRS.Frame:GetTop() - GetScreenHeight()
			ConsRS.Frame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["left"], ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["top"])
		end
	end)
	ConsRS.Frame.FFX:SetScript("OnHide", function(self)
		if ( ConsRS.Frame.isMoving ) then
			ConsRS.Frame:StopMovingOrSizing();
			ConsRS.Frame.isMoving = false;
			ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["left"] = ConsRS.Frame:GetLeft()
			ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["top"] = ConsRS.Frame:GetTop() - GetScreenHeight()
			ConsRS.Frame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["left"], ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["top"])
		end
	end)
	ConsRS.Frame.FFX.FS1 = ConsRS.Frame.FFX:CreateFontString("ConsRS_Frame_FF1S","ARTWORK", "ChatFontNormal")
	ConsRS.Frame.FFX.FS1:SetParent(ConsRS.Frame.FFX)
	ConsRS.Frame.FFX.FS1:SetPoint("LEFT",ConsRS.Frame.FFX,"LEFT",0,0)
	ConsRS.Frame.FFX.FS1:SetWidth(60)
	ConsRS.Frame.FFX.FS1:SetHeight(38)
	ConsRS.Frame.FFX.FS1:SetJustifyH("CENTER")
	ConsRS.Frame.FFX.FS1:SetFontObject("GameFontNormalLarge")
	ConsRS.Frame.FFX.FS1:SetText("C:Sort")
	ConsRS.Frame.FFX.FS1:SetTextColor(1, 1, 0)
	
	ConsRS.Frame32 = CreateFrame("frame", "ConsRSMainF2rame2", UIParent)
	ConsRS.Frame32:SetWidth(150)
	ConsRS.Frame32:SetHeight(60)
	ConsRS.Frame32:Hide()
	ConsRS.Frame32:SetMovable(true)
	ConsRS.Frame32:EnableMouse(true)
	ConsRS.Frame32:SetFrameStrata("LOW")
	ConsRS.Frame32:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
	ConsRS.Frame32:SetBackdrop( { 
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", 
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = true, tileSize = 10, edgeSize = 10, insets = { left = 2, right = 2, top = 2, bottom = 2 }
	});
	ConsRS.Frame32:SetScript("OnMouseDown", function(self, button)
			ConsRS.Frame32:StartMoving();
			ConsRS.Frame32.isMoving = true;
	end)
	ConsRS.Frame32:SetScript("OnMouseUp", function(self, button)
		if ConsRS.Frame32.isMoving then
			ConsRS.Frame32:StopMovingOrSizing();
			ConsRS.Frame32.isMoving = false;
		end
	end)
	ConsRS.Frame32:SetScript("OnHide", function(self)
		if ( ConsRS.Frame32.isMoving ) then
			ConsRS.Frame32:StopMovingOrSizing();
			ConsRS.Frame32.isMoving = false;
		end
	end)
	ConsRS.Frame32:SetScale(0.7)
	ConsRS.Frame32.FS1 = ConsRS.Frame32:CreateFontString("ConsRS_Frame_FF1S","ARTWORK", "ChatFontNormal")
	ConsRS.Frame32.FS1:SetParent(ConsRS.Frame32)
	ConsRS.Frame32.FS1:SetPoint("TOP",ConsRS.Frame32,"TOP",0,0)
	ConsRS.Frame32.FS1:SetWidth(150)
	ConsRS.Frame32.FS1:SetHeight(38)
	ConsRS.Frame32.FS1:SetJustifyH("CENTER")
	ConsRS.Frame32.FS1:SetFontObject("GameFontNormalLarge")
	ConsRS.Frame32.FS1:SetText("C:Sorting Raid")
	ConsRS.Frame32.FS1:SetTextColor(1, 1, 0)
	ConsRS.Frame32.FS2 = ConsRS.Frame32:CreateFontString("ConsRS_Frame_FF1S","ARTWORK", "ChatFontNormal")
	ConsRS.Frame32.FS2:SetParent(ConsRS.Frame32)
	ConsRS.Frame32.FS2:SetPoint("TOP",ConsRS.Frame32,"TOP",0,-20)
	ConsRS.Frame32.FS2:SetWidth(150)
	ConsRS.Frame32.FS2:SetHeight(38)
	ConsRS.Frame32.FS2:SetJustifyH("CENTER")
	ConsRS.Frame32.FS2:SetFontObject("GameFontNormalLarge")
	ConsRS.Frame32.FS2:SetText("0/40")
	ConsRS.Frame32.FS2:SetTextColor(1, 1, 0)


	
	ConsRS.Frame3 = CreateFrame("frame", "ConsRSMainF2rame2", UIParent)
	ConsRS.Frame3:SetWidth(250)
	ConsRS.Frame3:SetHeight(90)
	ConsRS.Frame3:SetMovable(true)
	ConsRS.Frame3:EnableMouse(true)
	ConsRS.Frame3:SetFrameStrata("LOW")
	ConsRS.Frame3:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
	ConsRS.Frame3:SetBackdrop( { 
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", 
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = true, tileSize = 10, edgeSize = 10, insets = { left = 2, right = 2, top = 2, bottom = 2 }
	});
	ConsRS.Frame3:SetScript("OnMouseDown", function(self, button)
			ConsRS.Frame3:StartMoving();
			ConsRS.Frame3.isMoving = true;
	end)
	ConsRS.Frame3:SetScript("OnMouseUp", function(self, button)
		if ConsRS.Frame3.isMoving then
			ConsRS.Frame3:StopMovingOrSizing();
			ConsRS.Frame3.isMoving = false;
		end
	end)
	ConsRS.Frame3:SetScript("OnHide", function(self)
		if ( ConsRS.Frame3.isMoving ) then
			ConsRS.Frame3:StopMovingOrSizing();
			ConsRS.Frame3.isMoving = false;
		end
	end)
	ConsRS.Frame3:SetScale(0.7)
	ConsRS.Frame3.FS1 = ConsRS.Frame3:CreateFontString("ConsRS_Frame_FF21S","ARTWORK", "ChatFontNormal")
	ConsRS.Frame3.FS1:SetParent(ConsRS.Frame3)
	ConsRS.Frame3.FS1:SetPoint("TOP",ConsRS.Frame3,"TOP",0,0)
	ConsRS.Frame3.FS1:SetWidth(250)
	ConsRS.Frame3.FS1:SetHeight(38)
	ConsRS.Frame3.FS1:SetJustifyH("TOP")
	ConsRS.Frame3.FS1:SetFontObject("GameFontNormalLarge")
	ConsRS.Frame3.FS1:SetText("Save Current Raid")
	ConsRS.Frame3.FS1:SetTextColor(1, 1, 0)
	
	ConsRS.Frame3.FS2 = ConsRS.Frame3:CreateFontString("ConsRS_Frame_FFs21S","ARTWORK", "ChatFontNormal")
	ConsRS.Frame3.FS2:SetParent(ConsRS.Frame3)
	ConsRS.Frame3.FS2:SetPoint("TOPLEFT",ConsRS.Frame3,"TOPLEFT",5,-25)
	ConsRS.Frame3.FS2:SetWidth(250)
	ConsRS.Frame3.FS2:SetHeight(38)
	ConsRS.Frame3.FS2:SetJustifyH("LEFT")
	ConsRS.Frame3.FS2:SetFontObject("GameFontNormalLarge")
	ConsRS.Frame3.FS2:SetText("SaveName:")
	ConsRS.Frame3.FS2:SetTextColor(1, 1, 0)
	
	ConsRS.Frame3.editFrame = CreateFrame("EditBox", nil, UIConfig, "InputBoxTemplate");
	ConsRS.Frame3.editFrame:SetPoint("TOPLEFT", ConsRS.Frame3, "TOPLEFT", 115, -33);
	ConsRS.Frame3.editFrame:SetParent(ConsRS.Frame3)
	ConsRS.Frame3.editFrame:SetWidth(130);
	ConsRS.Frame3.editFrame:SetHeight(25);
	ConsRS.Frame3.editFrame:SetMovable(false);
	ConsRS.Frame3.editFrame:SetAutoFocus(false);
	ConsRS.Frame3.editFrame:SetMaxLetters(32000);
	ConsRS.Frame3.editFrame:SetScript("OnEnterPressed", function(self)
		ConsRS.Frame3.editFrame:ClearFocus()
	end);
	ConsRS.Frame3.F2 = CreateFrame("frame", "ConsRSMainFrame3", ConsRS.Frame3)
	ConsRS.Frame3.F2:SetWidth(65)
	ConsRS.Frame3.F2:SetHeight(25)
	ConsRS.Frame3.F2:SetMovable(true)
	ConsRS.Frame3.F2:EnableMouse(true)
	ConsRS.Frame3.F2:SetFrameStrata("LOW")
	ConsRS.Frame3.F2:SetPoint("BOTTOMRIGHT", ConsRS.Frame3, "BOTTOMRIGHT", 0, 0)
	ConsRS.Frame3.F2:SetBackdrop( { 
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", 
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = true, tileSize = 10, edgeSize = 10, insets = { left = 2, right = 2, top = 2, bottom = 2 }
	});
	ConsRS.Frame3.F2:SetScript("OnMouseDown", function(self, button)
			if button == "RightButton" then
				ConsRS.Frame3:StartMoving();
				ConsRS.Frame3.isMoving = true;
			else
				ConsRS.Frame3:StopMovingOrSizing();
				ConsRS.Frame3.isMoving = false;
				local ZeName = ConsRS.Frame3.editFrame:GetText()
				if (ConsRSVar1["SavedRaids"][ZeName]) then
					print("ConsRaidSorter - Error: "..ZeName.." is taken allready!")
				elseif (ZeName == "" or ZeName == nil) then
					print("ConsRaidSorter - Error: Need to be named something!")
				else
					ConsRS.SaveRaid(ZeName)
					ConsRS.Frame3:Hide()
					ConsRS.ListLines()
				end
			end
	end)
	ConsRS.Frame3.F2:SetScript("OnMouseUp", function(self, button)
		if button == "RightButton" and ConsRS.Frame3.isMoving then
			ConsRS.Frame3:StopMovingOrSizing();
			ConsRS.Frame3.isMoving = false;
		end
	end)
	ConsRS.Frame3.F2:SetScript("OnHide", function(self)
		if ( ConsRS.Frame3.isMoving ) then
			ConsRS.Frame3:StopMovingOrSizing();
			ConsRS.Frame3.isMoving = false;
		end
	end)
	ConsRS.Frame3.FS1 = ConsRS.Frame3:CreateFontString("ConsRS_Frame_FF1S","ARTWORK", "ChatFontNormal")
	ConsRS.Frame3.FS1:SetParent(ConsRS.Frame3.F2)
	ConsRS.Frame3.FS1:SetPoint("TOP",ConsRS.Frame3.F2,"TOP",0,0)
	ConsRS.Frame3.FS1:SetWidth(65)
	ConsRS.Frame3.FS1:SetHeight(25)
	ConsRS.Frame3.FS1:SetJustifyH("CENTER")
	ConsRS.Frame3.FS1:SetFontObject("GameFontNormalLarge")
	ConsRS.Frame3.FS1:SetText("Save")
	ConsRS.Frame3.FS1:SetTextColor(0, 1, 0)
	ConsRS.Frame31 = CreateFrame("frame", "ConsRSMaiznF2rame2", UIParent)
	ConsRS.Frame31:SetWidth(250)
	ConsRS.Frame31:SetHeight(90)
	ConsRS.Frame31:SetMovable(true)
	ConsRS.Frame31:EnableMouse(true)
	ConsRS.Frame31:SetFrameStrata("LOW")
	ConsRS.Frame31:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
	ConsRS.Frame31:SetBackdrop( { 
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", 
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = true, tileSize = 10, edgeSize = 10, insets = { left = 2, right = 2, top = 2, bottom = 2 }
	});
	ConsRS.Frame31:SetScript("OnMouseDown", function(self, button)
			ConsRS.Frame31:StartMoving();
			ConsRS.Frame31.isMoving = true;
	end)
	ConsRS.Frame31:SetScript("OnMouseUp", function(self, button)
		if ConsRS.Frame31.isMoving then
			ConsRS.Frame31:StopMovingOrSizing();
			ConsRS.Frame31.isMoving = false;
		end
	end)
	ConsRS.Frame31:SetScript("OnHide", function(self)
		if ( ConsRS.Frame31.isMoving ) then
			ConsRS.Frame31:StopMovingOrSizing();
			ConsRS.Frame31.isMoving = false;
		end
	end)
	ConsRS.Frame31:SetScale(0.7)
	ConsRS.Frame31.FS1 = ConsRS.Frame31:CreateFontString("ConsRS_Frame_FF21S","ARTWORK", "ChatFontNormal")
	ConsRS.Frame31.FS1:SetParent(ConsRS.Frame31)
	ConsRS.Frame31.FS1:SetPoint("TOP",ConsRS.Frame31,"TOP",0,0)
	ConsRS.Frame31.FS1:SetWidth(250)
	ConsRS.Frame31.FS1:SetHeight(38)
	ConsRS.Frame31.FS1:SetJustifyH("TOP")
	ConsRS.Frame31.FS1:SetFontObject("GameFontNormalLarge")
	ConsRS.Frame31.FS1:SetText("Make a new Raidcomp")
	ConsRS.Frame31.FS1:SetTextColor(1, 1, 0)
	
	ConsRS.Frame31.FS2 = ConsRS.Frame31:CreateFontString("ConsRS_Frame_FFs21S","ARTWORK", "ChatFontNormal")
	ConsRS.Frame31.FS2:SetParent(ConsRS.Frame31)
	ConsRS.Frame31.FS2:SetPoint("TOPLEFT",ConsRS.Frame31,"TOPLEFT",5,-25)
	ConsRS.Frame31.FS2:SetWidth(250)
	ConsRS.Frame31.FS2:SetHeight(38)
	ConsRS.Frame31.FS2:SetJustifyH("LEFT")
	ConsRS.Frame31.FS2:SetFontObject("GameFontNormalLarge")
	ConsRS.Frame31.FS2:SetText("SaveName:")
	ConsRS.Frame31.FS2:SetTextColor(1, 1, 0)
	
	ConsRS.Frame31.editFrame = CreateFrame("EditBox", nil, UIConfig, "InputBoxTemplate");
	ConsRS.Frame31.editFrame:SetPoint("TOPLEFT", ConsRS.Frame31, "TOPLEFT", 115, -33);
	ConsRS.Frame31.editFrame:SetParent(ConsRS.Frame31)
	ConsRS.Frame31.editFrame:SetWidth(130);
	ConsRS.Frame31.editFrame:SetHeight(25);
	ConsRS.Frame31.editFrame:SetMovable(false);
	ConsRS.Frame31.editFrame:SetAutoFocus(false);
	ConsRS.Frame31.editFrame:SetMaxLetters(32000);
	ConsRS.Frame31.editFrame:SetScript("OnEnterPressed", function(self)
		ConsRS.Frame31.editFrame:ClearFocus()
	end);
	ConsRS.Frame31.F2 = CreateFrame("frame", "ConsRSMainFrame3", ConsRS.Frame31)
	ConsRS.Frame31.F2:SetWidth(65)
	ConsRS.Frame31.F2:SetHeight(25)
	ConsRS.Frame31.F2:SetMovable(true)
	ConsRS.Frame31.F2:EnableMouse(true)
	ConsRS.Frame31.F2:SetFrameStrata("LOW")
	ConsRS.Frame31.F2:SetPoint("BOTTOMRIGHT", ConsRS.Frame31, "BOTTOMRIGHT", 0, 0)
	ConsRS.Frame31.F2:SetBackdrop( { 
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", 
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = true, tileSize = 10, edgeSize = 10, insets = { left = 2, right = 2, top = 2, bottom = 2 }
	});
	ConsRS.Frame31.F2:SetScript("OnMouseDown", function(self, button)
			if button == "RightButton" then
				ConsRS.Frame31:StartMoving();
				ConsRS.Frame31.isMoving = true;
			else
				ConsRS.Frame31:StopMovingOrSizing();
				ConsRS.Frame31.isMoving = false;
				local ztext = ConsRS.Frame31.editFrame:GetText()
				if (ConsRSVar1["SavedRaids"][ztext]) then
					print("ConsRaidSorter - Error: "..ztext.." is taken allready!")
				elseif (ztext == "" or ztext == nil) then
					print("ConsRaidSorter - Error: Need to be named something!")
				else
					ConsRS.MakeRaidTemplate(ztext)
					ConsRS.Frame31.editFrame:SetText("")
					ConsRS.Frame31:Hide()
					ConsRS.ListLines()
				end
			end
	end)
	ConsRS.Frame31.F2:SetScript("OnMouseUp", function(self, button)
		if button == "RightButton" and ConsRS.Frame31.isMoving then
			ConsRS.Frame31:StopMovingOrSizing();
			ConsRS.Frame31.isMoving = false;
		end
	end)
	ConsRS.Frame31.F2:SetScript("OnHide", function(self)
		if ( ConsRS.Frame31.isMoving ) then
			ConsRS.Frame31:StopMovingOrSizing();
			ConsRS.Frame31.isMoving = false;
		end
	end)
	ConsRS.Frame31.FS1 = ConsRS.Frame31:CreateFontString("ConsRS_Frame_FF1S","ARTWORK", "ChatFontNormal")
	ConsRS.Frame31.FS1:SetParent(ConsRS.Frame31.F2)
	ConsRS.Frame31.FS1:SetPoint("TOP",ConsRS.Frame31.F2,"TOP",0,0)
	ConsRS.Frame31.FS1:SetWidth(65)
	ConsRS.Frame31.FS1:SetHeight(25)
	ConsRS.Frame31.FS1:SetJustifyH("CENTER")
	ConsRS.Frame31.FS1:SetFontObject("GameFontNormalLarge")
	ConsRS.Frame31.FS1:SetText("Save")
	ConsRS.Frame31.FS1:SetTextColor(0, 1, 0)
	ConsRS.Frame31.F22 = CreateFrame("frame", "ConsRSMainFr22ame3", ConsRS.Frame31)
	ConsRS.Frame31.F22:SetWidth(65)
	ConsRS.Frame31.F22:SetHeight(25)
	ConsRS.Frame31.F22:SetMovable(true)
	ConsRS.Frame31.F22:EnableMouse(true)
	ConsRS.Frame31.F22:SetFrameStrata("LOW")
	ConsRS.Frame31.F22:SetPoint("BOTTOMLEFT", ConsRS.Frame31, "BOTTOMLEFT", 0, 0)
	ConsRS.Frame31.F22:SetBackdrop( { 
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", 
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = true, tileSize = 10, edgeSize = 10, insets = { left = 2, right = 2, top = 2, bottom = 2 }
	});
	ConsRS.Frame31.F22:SetScript("OnMouseDown", function(self, button)
			if button == "RightButton" then
				ConsRS.Frame31:StartMoving();
				ConsRS.Frame31.isMoving = true;
			else
				ConsRS.Frame31:StopMovingOrSizing();
				ConsRS.Frame31.isMoving = false;
				ConsRS.Frame31:Hide()
			end
	end)
	ConsRS.Frame31.F22:SetScript("OnMouseUp", function(self, button)
		if button == "RightButton" and ConsRS.Frame31.isMoving then
			ConsRS.Frame31:StopMovingOrSizing();
			ConsRS.Frame31.isMoving = false;
		end
	end)
	ConsRS.Frame31.F22:SetScript("OnHide", function(self)
		if ( ConsRS.Frame31.isMoving ) then
			ConsRS.Frame31:StopMovingOrSizing();
			ConsRS.Frame31.isMoving = false;
		end
	end)
	ConsRS.Frame31.FS122 = ConsRS.Frame31:CreateFontString("ConsRS_Fr22ame_FF1S","ARTWORK", "ChatFontNormal")
	ConsRS.Frame31.FS122:SetParent(ConsRS.Frame31.F22)
	ConsRS.Frame31.FS122:SetPoint("TOP",ConsRS.Frame31.F22,"TOP",0,0)
	ConsRS.Frame31.FS122:SetWidth(65)
	ConsRS.Frame31.FS122:SetHeight(25)
	ConsRS.Frame31.FS122:SetJustifyH("CENTER")
	ConsRS.Frame31.FS122:SetFontObject("GameFontNormalLarge")
	ConsRS.Frame31.FS122:SetText("Cancel")
	ConsRS.Frame31.FS122:SetTextColor(0, 1, 0)
	ConsRS.Frame31:Hide()
	ConsRS.Frame3.F22 = CreateFrame("frame", "ConsRSMainFr22ame3", ConsRS.Frame3)
	ConsRS.Frame3.F22:SetWidth(65)
	ConsRS.Frame3.F22:SetHeight(25)
	ConsRS.Frame3.F22:SetMovable(true)
	ConsRS.Frame3.F22:EnableMouse(true)
	ConsRS.Frame3.F22:SetFrameStrata("LOW")
	ConsRS.Frame3.F22:SetPoint("BOTTOMLEFT", ConsRS.Frame3, "BOTTOMLEFT", 0, 0)
	ConsRS.Frame3.F22:SetBackdrop( { 
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", 
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = true, tileSize = 10, edgeSize = 10, insets = { left = 2, right = 2, top = 2, bottom = 2 }
	});
	ConsRS.Frame3.F22:SetScript("OnMouseDown", function(self, button)
			if button == "RightButton" then
				ConsRS.Frame3:StartMoving();
				ConsRS.Frame3.isMoving = true;
			else
				ConsRS.Frame3:StopMovingOrSizing();
				ConsRS.Frame3.isMoving = false;
				ConsRS.Frame3:Hide()
			end
	end)
	ConsRS.Frame3.F22:SetScript("OnMouseUp", function(self, button)
		if button == "RightButton" and ConsRS.Frame3.isMoving then
			ConsRS.Frame3:StopMovingOrSizing();
			ConsRS.Frame3.isMoving = false;
		end
	end)
	ConsRS.Frame3.F22:SetScript("OnHide", function(self)
		if ( ConsRS.Frame3.isMoving ) then
			ConsRS.Frame3:StopMovingOrSizing();
			ConsRS.Frame3.isMoving = false;
		end
	end)
	ConsRS.Frame3.FS122 = ConsRS.Frame3:CreateFontString("ConsRS_Fr22ame_FF1S","ARTWORK", "ChatFontNormal")
	ConsRS.Frame3.FS122:SetParent(ConsRS.Frame3.F22)
	ConsRS.Frame3.FS122:SetPoint("TOP",ConsRS.Frame3.F22,"TOP",0,0)
	ConsRS.Frame3.FS122:SetWidth(65)
	ConsRS.Frame3.FS122:SetHeight(25)
	ConsRS.Frame3.FS122:SetJustifyH("CENTER")
	ConsRS.Frame3.FS122:SetFontObject("GameFontNormalLarge")
	ConsRS.Frame3.FS122:SetText("Cancel")
	ConsRS.Frame3.FS122:SetTextColor(0, 1, 0)
	ConsRS.Frame3:Hide()
	ConsRS.Frame4 = CreateFrame("frame", "ConsRSMainF2rasme2", UIParent)
	ConsRS.Frame4:SetWidth(250)
	ConsRS.Frame4:SetHeight(90)
	ConsRS.Frame4:SetMovable(true)
	ConsRS.Frame4:EnableMouse(true)
	ConsRS.Frame4:SetFrameStrata("LOW")
	ConsRS.Frame4:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
	ConsRS.Frame4:SetBackdrop( { 
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", 
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = true, tileSize = 10, edgeSize = 10, insets = { left = 2, right = 2, top = 2, bottom = 2 }
	});
	ConsRS.Frame4:SetScript("OnMouseDown", function(self, button)
			ConsRS.Frame4:StartMoving();
			ConsRS.Frame4.isMoving = true;
	end)
	ConsRS.Frame4:SetScript("OnMouseUp", function(self, button)
		if ConsRS.Frame4.isMoving then
			ConsRS.Frame4:StopMovingOrSizing();
			ConsRS.Frame4.isMoving = false;
		end
	end)
	ConsRS.Frame4:SetScript("OnHide", function(self)
		if ( ConsRS.Frame4.isMoving ) then
			ConsRS.Frame4:StopMovingOrSizing();
			ConsRS.Frame4.isMoving = false;
		end
	end)
	ConsRS.Frame4:SetScale(0.7)
	ConsRS.Frame4.FS1 = ConsRS.Frame4:CreateFontString("ConsRS_Frame_FF21S","ARTWORK", "ChatFontNormal")
	ConsRS.Frame4.FS1:SetParent(ConsRS.Frame4)
	ConsRS.Frame4.FS1:SetPoint("TOP",ConsRS.Frame4,"TOP",0,0)
	ConsRS.Frame4.FS1:SetWidth(250)
	ConsRS.Frame4.FS1:SetHeight(38)
	ConsRS.Frame4.FS1:SetJustifyH("TOP")
	ConsRS.Frame4.FS1:SetFontObject("GameFontNormalLarge")
	ConsRS.Frame4.FS1:SetText("Selected:")
	ConsRS.Frame4.FS1:SetTextColor(1, 1, 0)
	
	ConsRS.Frame4.FS2 = ConsRS.Frame4:CreateFontString("ConsRS_zFrsame_FFs21S","ARTWORK", "ChatFontNormal")
	ConsRS.Frame4.FS2:SetParent(ConsRS.Frame4)
	ConsRS.Frame4.FS2:SetPoint("TOP",ConsRS.Frame4,"TOP",0,-25)
	ConsRS.Frame4.FS2:SetWidth(250)
	ConsRS.Frame4.FS2:SetHeight(38)
	ConsRS.Frame4.FS2:SetJustifyH("CENTER")
	ConsRS.Frame4.FS2:SetFontObject("GameFontNormalLarge")
	ConsRS.Frame4.FS2:SetText("SaveName")
	ConsRS.Frame4.FS2:SetTextColor(1, 1, 0)

	ConsRS.Frame4.F2x = CreateFrame("frame", "ConsRSMainFrame54", ConsRS.Frame4)
	ConsRS.Frame4.F2x:SetWidth(90)
	ConsRS.Frame4.F2x:SetHeight(25)
	ConsRS.Frame4.F2x:SetMovable(true)
	ConsRS.Frame4.F2x:EnableMouse(true)
	ConsRS.Frame4.F2x:SetFrameStrata("LOW")
	ConsRS.Frame4.F2x:SetPoint("BOTTOM", ConsRS.Frame4, "BOTTOM", 12, 0)
	ConsRS.Frame4.F2x:SetBackdrop( { 
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", 
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = true, tileSize = 10, edgeSize = 10, insets = { left = 2, right = 2, top = 2, bottom = 2 }
	});
	ConsRS.Frame4.F2x:SetScript("OnMouseDown", function(self, button)
			if button == "RightButton" then
				ConsRS.Frame4:StartMoving();
				ConsRS.Frame4.isMoving = true;
			else
				ConsRS.Frame4:StopMovingOrSizing();
				ConsRS.Frame4.isMoving = false;
				ConsRS.RaidName = ConsRS.Frame4.FS2:GetText()
				ConsRS.LoadRaid()
				ConsRS.Frame4:Hide()
				ConsRS.Fx3:Show()
				ConsRS.FG1:Show()
				ConsRS.PosRaidFrames()
			end
	end)
	ConsRS.Frame4.F2x:SetScript("OnMouseUp", function(self, button)
		if button == "RightButton" and ConsRS.Frame4.isMoving then
			ConsRS.PosRaidFrames()
			ConsRS.Frame4:StopMovingOrSizing();
			ConsRS.Frame4.isMoving = false;
		end
	end)
	ConsRS.Frame4.F2x:SetScript("OnHide", function(self)
		if ( ConsRS.Frame4.isMoving ) then
			ConsRS.Frame4:StopMovingOrSizing();
			ConsRS.Frame4.isMoving = false;
		end
	end)
	ConsRS.Frame4.FS1x4 = ConsRS.Frame4:CreateFontString("ConsRS_Fr4ame_FF1S","ARTWORK", "ChatFontNormal")
	ConsRS.Frame4.FS1x4:SetParent(ConsRS.Frame4.F2x)
	ConsRS.Frame4.FS1x4:SetPoint("TOP",ConsRS.Frame4.F2x,"TOP",0,0)
	ConsRS.Frame4.FS1x4:SetWidth(90)
	ConsRS.Frame4.FS1x4:SetHeight(25)
	ConsRS.Frame4.FS1x4:SetJustifyH("CENTER")
	ConsRS.Frame4.FS1x4:SetFontObject("GameFontNormalLarge")
	ConsRS.Frame4.FS1x4:SetText("Edit Raid")
	ConsRS.Frame4.FS1x4:SetTextColor(0, 1, 0)

	ConsRS.Frame4.F2 = CreateFrame("frame", "ConsRSMainFrame4s", ConsRS.Frame4)
	ConsRS.Frame4.F2:SetWidth(90)
	ConsRS.Frame4.F2:SetHeight(25)
	ConsRS.Frame4.F2:SetMovable(true)
	ConsRS.Frame4.F2:EnableMouse(true)
	ConsRS.Frame4.F2:SetFrameStrata("LOW")
	ConsRS.Frame4.F2:SetPoint("BOTTOMLEFT", ConsRS.Frame4, "BOTTOMLEFT", 0, 0)
	ConsRS.Frame4.F2:SetBackdrop( { 
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", 
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = true, tileSize = 10, edgeSize = 10, insets = { left = 2, right = 2, top = 2, bottom = 2 }
	});
	ConsRS.Frame4.F2:SetScript("OnMouseDown", function(self, button)
			if button == "RightButton" then
				ConsRS.Frame4:StartMoving();
				ConsRS.Frame4.isMoving = true;
			else
				ConsRS.Frame4:StopMovingOrSizing();
				ConsRS.Frame4.isMoving = false;
				ConsRS.RaidName = ConsRS.Frame4.FS2:GetText()
				--ConsRS.SortRaid(ConsRS.RaidName)
ConsRS.testMove()
				ConsRS.Frame4:Hide()
			end
	end)
	ConsRS.Frame4.F2:SetScript("OnMouseUp", function(self, button)
		if button == "RightButton" and ConsRS.Frame4.isMoving then
			ConsRS.Frame4:StopMovingOrSizing();
			ConsRS.Frame4.isMoving = false;
		end
	end)
	ConsRS.Frame4.F2:SetScript("OnHide", function(self)
		if ( ConsRS.Frame4.isMoving ) then
			ConsRS.Frame4:StopMovingOrSizing();
			ConsRS.Frame4.isMoving = false;
		end
	end)
	ConsRS.Frame4.FS1 = ConsRS.Frame4:CreateFontString("ConsxsRS_Frame_FF1S","ARTWORK", "ChatFontNormal")
	ConsRS.Frame4.FS1:SetParent(ConsRS.Frame4.F2)
	ConsRS.Frame4.FS1:SetPoint("TOP",ConsRS.Frame4.F2,"TOP",0,0)
	ConsRS.Frame4.FS1:SetWidth(90)
	ConsRS.Frame4.FS1:SetHeight(25)
	ConsRS.Frame4.FS1:SetJustifyH("CENTER")
	ConsRS.Frame4.FS1:SetFontObject("GameFontNormalLarge")
	ConsRS.Frame4.FS1:SetText("Sort Raid")
	ConsRS.Frame4.FS1:SetTextColor(0, 1, 0)
	ConsRS.Frame4:Hide()
	ConsRS.Frame4.F3 = CreateFrame("frame", "ConsRSMainFrame5", ConsRS.Frame4)
	ConsRS.Frame4.F3:SetWidth(65)
	ConsRS.Frame4.F3:SetHeight(25)
	ConsRS.Frame4.F3:SetMovable(true)
	ConsRS.Frame4.F3:EnableMouse(true)
	ConsRS.Frame4.F3:SetFrameStrata("LOW")
	ConsRS.Frame4.F3:SetPoint("BOTTOMRIGHT", ConsRS.Frame4, "BOTTOMRIGHT", 0, 0)
	ConsRS.Frame4.F3:SetBackdrop( { 
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", 
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = true, tileSize = 10, edgeSize = 10, insets = { left = 2, right = 2, top = 2, bottom = 2 }
	});
	ConsRS.Frame4.F3:SetScript("OnMouseDown", function(self, button)
			if button == "RightButton" then
				ConsRS.Frame4:StartMoving();
				ConsRS.Frame4.isMoving = true;
			else
				ConsRS.Frame4:StopMovingOrSizing();
				ConsRS.Frame4.isMoving = false;
				ConsRS.Frame4:Hide()
			end
	end)
	ConsRS.Frame4.F3:SetScript("OnMouseUp", function(self, button)
		if button == "RightButton" and ConsRS.Frame4.isMoving then
			ConsRS.Frame4:StopMovingOrSizing();
			ConsRS.Frame4.isMoving = false;
		end
	end)
	ConsRS.Frame4.F3:SetScript("OnHide", function(self)
		if ( ConsRS.Frame4.isMoving ) then
			ConsRS.Frame4:StopMovingOrSizing();
			ConsRS.Frame4.isMoving = false;
		end
	end)
	ConsRS.Frame4.FS6 = ConsRS.Frame4:CreateFontString("ConsRS_Frame_FF1S","ARTWORK", "ChatFontNormal")
	ConsRS.Frame4.FS6:SetParent(ConsRS.Frame4.F3)
	ConsRS.Frame4.FS6:SetPoint("TOP",ConsRS.Frame4.F3,"TOP",0,0)
	ConsRS.Frame4.FS6:SetWidth(65)
	ConsRS.Frame4.FS6:SetHeight(25)
	ConsRS.Frame4.FS6:SetJustifyH("CENTER")
	ConsRS.Frame4.FS6:SetFontObject("GameFontNormalLarge")
	ConsRS.Frame4.FS6:SetText("Cancel")
	ConsRS.Frame4.FS6:SetTextColor(0, 1, 0)
	ConsRS.Fx3 = CreateFrame("frame", "ConsRSMainFramex", UIParent)
	ConsRS.Fx3:SetWidth(1)
	ConsRS.Fx3:SetHeight(1)
	ConsRS.Fx3:SetMovable(true)
	ConsRS.Fx3:EnableMouse(true)
	ConsRS.Fx3:SetFrameStrata("LOW")
	ConsRS.Fx3:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
	ConsRS.Fx3.F = CreateFrame("frame", "ConsRSMainFramex2", ConsRS.Fx3)
	ConsRS.Fx3.F:SetWidth(150)
	ConsRS.Fx3.F:SetHeight(25)
	ConsRS.Fx3.F:SetMovable(true)
	ConsRS.Fx3.F:EnableMouse(true)
	ConsRS.Fx3.F:SetFrameStrata("LOW")
	ConsRS.Fx3:Hide()
	ConsRS.Fx3.F:SetPoint("TOPLEFT", ConsRS.Fx3, "TOPLEFT", 10, 0)
	ConsRS.Fx3.F:SetBackdrop( { 
		bgFile = "Interface\\Buttons\\WHITE8X8", tile = false, tileSize=0,
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = true, tileSize = 10, edgeSize = 10, insets = { left = 2, right = 2, top = 2, bottom = 2 }
	});
	ConsRS.Fx3.F:SetBackdropColor(0.5,0,0,1)
	ConsRS.Fx3.F:SetScript("OnMouseDown", function(self, button)
			if button == "LeftButton" then
				ConsRS.PosRaidFrames()
				ConsRS.Fx3:StartMoving();
				ConsRS.Fx3.isMoving = true;
			end
	end)
	ConsRS.Fx3.F:SetScript("OnMouseUp", function(self, button)
		if button == "LeftButton" and ConsRS.Fx3.isMoving then
			ConsRS.PosRaidFrames()
			ConsRS.Fx3:StopMovingOrSizing();
			ConsRS.Fx3.isMoving = false;
		end
	end)
	ConsRS.Fx3.F:SetScript("OnHide", function(self)
		if ( ConsRS.Fx3.isMoving ) then
			ConsRS.Fx3:StopMovingOrSizing();
			ConsRS.Fx3.isMoving = false;
		end
	end)
	ConsRS.Fx3.F["FS"] = ConsRS.Fx3.F:CreateFontString("ConsRS_Fx3_FFSxx","ARTWORK", "ChatFontNormal")
	ConsRS.Fx3.F["FS"]:SetParent(ConsRS.Fx3.F)
	ConsRS.Fx3.F["FS"]:SetPoint("LEFT",ConsRS.Fx3.F,"LEFT",0,0)
	ConsRS.Fx3.F["FS"]:SetWidth(150)
	ConsRS.Fx3.F["FS"]:SetHeight(20)
	ConsRS.Fx3.F["FS"]:SetJustifyH("CENTER")
	ConsRS.Fx3.F["FS"]:SetFontObject("GameFontNormalLarge")
	ConsRS.Fx3.F["FS"]:SetText("Classes")
	ConsRS.Fx3.F:SetScale(0.9)
	for CLi = 1, 8 do
		ConsRS.Fx3.F[CLi] = CreateFrame("frame", "ConsRS_Frame_FF"..CLi, ConsRS.Fx3.F)
		ConsRS.Fx3.F[CLi]:SetWidth(150)
		ConsRS.Fx3.F[CLi]:SetHeight(25)
		ConsRS.Fx3.F[CLi]:SetMovable(true)
		ConsRS.Fx3.F[CLi]:SetScript("OnMouseUp", function(self, button)
			if button == "LeftButton" and self.isMoving then
				self:SetFrameStrata("LOW")
				self:StopMovingOrSizing();
				self.isMoving = false;
				local zderp = 0
				for CLx = 1, 8 do
					if (ConsRS.RaidFramePos["g1"][1]) then
						local zleft, zright, ztop, zbottom = self:GetLeft(), self:GetRight(), self:GetTop(), self:GetBottom()
						local znr1, znr2, znr3, znr4 = ConsRS.RaidFramePos["g"..CLx][1], ConsRS.RaidFramePos["g"..CLx][2], ConsRS.RaidFramePos["g"..CLx][3], ConsRS.RaidFramePos["g"..CLx][4]
						if (znr1 > zleft + ((zright - zleft)/2) or znr2 < zright - ((zright - zleft)/2) or znr3 < ztop + ((zbottom - ztop)/2) or znr4 > zbottom - ((zbottom - ztop)/2)) then
						else
							zderp = CLx
						end
					end
				end
				if (zderp > 0) then
					ztext = self.FS:GetText()
					ConsRS.DragedToThis(zderp, CLi, ztext)
					self:ClearAllPoints()
					self:SetPoint("TOPLEFT", ConsRS.Fx3.F, "TOPLEFT",1,-((25*CLi)))
				else
					self:ClearAllPoints()
					self:SetPoint("TOPLEFT", ConsRS.Fx3.F, "TOPLEFT",1,-((25*CLi)))
				end
				ConsRS.AutoSaveRaid()
			end
		end)

		ConsRS.Fx3.F[CLi]:SetScript("OnMouseDown", function(self, button)
			if button == "LeftButton" and not self.isMoving then
				self:SetFrameStrata("HIGH")
				self:StartMoving();
				self.isMoving = true;
			end
		end)
		ConsRS.Fx3.F[CLi]:EnableMouse(true)
		ConsRS.Fx3.F[CLi]:SetPoint("TOPLEFT", ConsRS.Fx3.F, "TOPLEFT",0,-((25*CLi)))
		ConsRS.Fx3.F[CLi]:SetBackdrop( { 
			bgFile = "Interface\\Buttons\\WHITE8X8", tile = false, tileSize=0,
			edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
			tile = true, tileSize = 10, edgeSize = 10, insets = { left = 2, right = 2, top = 2, bottom = 2 }
		});
		ConsRS.Fx3.F[CLi]:SetBackdropColor(ConsRS.ClassColors[CLi][1],ConsRS.ClassColors[CLi][2],ConsRS.ClassColors[CLi][3],1)
		ConsRS.Fx3.F[CLi]["FS"] = ConsRS.Fx3.F[CLi]:CreateFontString("ConsRS_Fx3_FFS"..CLi,"ARTWORK", "ChatFontNormal")
		ConsRS.Fx3.F[CLi]["FS"]:SetParent(ConsRS.Fx3.F[CLi])
		ConsRS.Fx3.F[CLi]["FS"]:SetPoint("LEFT",ConsRS.Fx3.F[CLi],"LEFT",0,0)
		ConsRS.Fx3.F[CLi]["FS"]:SetWidth(150)
		ConsRS.Fx3.F[CLi]["FS"]:SetHeight(20)
		ConsRS.Fx3.F[CLi]["FS"]:SetJustifyH("CENTER")
		ConsRS.Fx3.F[CLi]["FS"]:SetFontObject("GameFontNormal")
		if (CLi == 1) then
			ConsRS.Fx3.F[CLi]["FS"]:SetText("Druid")
			ConsRS.Fx3.F[CLi]["FS"]:SetTextColor(1, 1, 0)
		elseif (CLi == 2) then
			ConsRS.Fx3.F[CLi]["FS"]:SetText("Hunter")
			ConsRS.Fx3.F[CLi]["FS"]:SetTextColor(1, 1, 0)
		elseif (CLi == 3) then
			ConsRS.Fx3.F[CLi]["FS"]:SetText("Mage")
			ConsRS.Fx3.F[CLi]["FS"]:SetTextColor(1, 1, 0)
		elseif (CLi == 4) then
			if (ConsRS.Faction == "Horde") then
				ConsRS.Fx3.F[CLi]["FS"]:SetText("Shaman")
				ConsRS.Fx3.F[CLi]["FS"]:SetTextColor(1, 1, 0)
			else
				ConsRS.Fx3.F[CLi]["FS"]:SetText("Paladin")
				ConsRS.Fx3.F[CLi]["FS"]:SetTextColor(1, 1, 0)
			end
		elseif (CLi == 5) then
			ConsRS.Fx3.F[CLi]["FS"]:SetText("Priest")
			ConsRS.Fx3.F[CLi]["FS"]:SetTextColor(1, 1, 0)
		elseif (CLi == 6) then
			ConsRS.Fx3.F[CLi]["FS"]:SetText("Rogue")
			ConsRS.Fx3.F[CLi]["FS"]:SetTextColor(1, 1, 0)
		elseif (CLi == 7) then
			ConsRS.Fx3.F[CLi]["FS"]:SetText("Warlock")
			ConsRS.Fx3.F[CLi]["FS"]:SetTextColor(1, 1, 0)
		elseif (CLi == 8) then
			ConsRS.Fx3.F[CLi]["FS"]:SetText("Warrior")
			ConsRS.Fx3.F[CLi]["FS"]:SetTextColor(1, 1, 0)
		end
	end
	
	
	
	ConsRS.FG1 = CreateFrame("frame", "ConsRSMainFramexg1", UIParent)
	ConsRS.FG1:SetWidth(1)
	ConsRS.FG1:SetHeight(1)
	ConsRS.FG1:SetMovable(true)
	ConsRS.FG1:EnableMouse(true)
	ConsRS.FG1:SetFrameStrata("LOW")
	ConsRS.FG1:Hide()
	ConsRS.FG1:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
	
	
	ConsRS.FG1.F22 = CreateFrame("frame", "ConsRSMainFr22ame3", ConsRS.FG1)
	ConsRS.FG1.F22:SetWidth(65)
	ConsRS.FG1.F22:SetHeight(25)
	ConsRS.FG1.F22:SetMovable(true)
	ConsRS.FG1.F22:EnableMouse(true)
	ConsRS.FG1.F22:SetFrameStrata("LOW")
	ConsRS.FG1.F22:SetPoint("BOTTOMLEFT", ConsRS.FG1, "TOPLEFT", 0, 13)
	ConsRS.FG1.F22:SetBackdrop( { 
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", 
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = true, tileSize = 10, edgeSize = 10, insets = { left = 2, right = 2, top = 2, bottom = 2 }
	});
	ConsRS.FG1.F22:SetScript("OnMouseDown", function(self, button)
			if button == "RightButton" then
				ConsRS.FG1:StartMoving();
				ConsRS.FG1.isMoving = true;
			else
				ConsRS.FG1:StopMovingOrSizing();
				ConsRS.FG1.isMoving = false;
				ConsRS.Fx3:Hide()
				ConsRS.FG1:Hide()
			end
	end)
	ConsRS.FG1.F22:SetScript("OnMouseUp", function(self, button)
		if button == "RightButton" and ConsRS.FG1.isMoving then
			ConsRS.FG1:StopMovingOrSizing();
			ConsRS.FG1.isMoving = false;
		end
	end)
	ConsRS.FG1.F22:SetScript("OnHide", function(self)
		if ( ConsRS.FG1.isMoving ) then
			ConsRS.FG1:StopMovingOrSizing();
			ConsRS.FG1.isMoving = false;
		end
	end)
	ConsRS.FG1.FS122 = ConsRS.FG1:CreateFontString("ConsRS_Fr2s2ame_FF1S","ARTWORK", "ChatFontNormal")
	ConsRS.FG1.FS122:SetParent(ConsRS.FG1.F22)
	ConsRS.FG1.FS122:SetPoint("TOP",ConsRS.FG1.F22,"TOP",0,0)
	ConsRS.FG1.FS122:SetWidth(65)
	ConsRS.FG1.FS122:SetHeight(25)
	ConsRS.FG1.FS122:SetJustifyH("CENTER")
	ConsRS.FG1.FS122:SetFontObject("GameFontNormalLarge")
	ConsRS.FG1.FS122:SetText("Close")
	ConsRS.FG1.FS122:SetTextColor(0, 1, 0)
	
	
	for CLi = 1, 8 do
		ConsRS.FG1["Fx"..CLi] = CreateFrame("frame", "ConsRSMainFramex2xx"..CLi, ConsRS.FG1)
		ConsRS.FG1["Fx"..CLi]:SetWidth(150)
		ConsRS.FG1["Fx"..CLi]:SetHeight(125)
		ConsRS.FG1["Fx"..CLi]:SetMovable(true)
		ConsRS.FG1["Fx"..CLi]:EnableMouse(true)
		ConsRS.FG1["Fx"..CLi]:SetFrameStrata("LOW")
		if (CLi < 5) then
			ConsRS.FG1["Fx"..CLi]:SetPoint("TOPLEFT", ConsRS.FG1, "TOPLEFT", (150*CLi)-150, 0)
		else
			ConsRS.FG1["Fx"..CLi]:SetPoint("TOPLEFT", ConsRS.FG1, "TOPLEFT", (150*(CLi-4))-150, -150)
		end
		ConsRS.FG1["Fx"..CLi]:SetBackdrop( { 
			bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", 
			edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
			tile = true, tileSize = 10, edgeSize = 10, insets = { left = 2, right = 2, top = 2, bottom = 2 }
		});
		ConsRS.FG1["Fx"..CLi]:SetScript("OnMouseDown", function(self, button)
				if button == "LeftButton" then
					ConsRS.PosRaidFrames()
					ConsRS.FG1:StartMoving();
					ConsRS.FG1.isMoving = true;
				end
		end)
		ConsRS.FG1["Fx"..CLi]:SetScript("OnMouseUp", function(self, button)
			if button == "LeftButton" and ConsRS.FG1.isMoving then
				ConsRS.FG1:StopMovingOrSizing();
				ConsRS.FG1.isMoving = false;
				for CLx = 1, 8 do
					ConsRS.RaidFramePos["g"..CLx][1] = ConsRS.FG1["Fx"..CLx]:GetLeft()
					ConsRS.RaidFramePos["g"..CLx][2] = ConsRS.FG1["Fx"..CLx]:GetRight()
					ConsRS.RaidFramePos["g"..CLx][3] = ConsRS.FG1["Fx"..CLx]:GetTop()
					ConsRS.RaidFramePos["g"..CLx][4] = ConsRS.FG1["Fx"..CLx]:GetBottom()
				end
				ConsRS.PosRaidFrames()
			end
		end)
		ConsRS.FG1["Fx"..CLi]:SetScript("OnHide", function(self)
			if ( ConsRS.FG1.isMoving ) then
				ConsRS.FG1:StopMovingOrSizing();
				ConsRS.FG1.isMoving = false;
			end
		end)
		ConsRS.FG1["Fx"..CLi]:SetScale(0.9)
		





		ConsRS.FG1["Fxz"..CLi] = CreateFrame("frame", "ConsRSMainFsramex2xx"..CLi, ConsRS.FG1)
		ConsRS.FG1["Fxz"..CLi]:SetWidth(150)
		ConsRS.FG1["Fxz"..CLi]:SetHeight(25)
		ConsRS.FG1["Fxz"..CLi]:SetMovable(true)
		ConsRS.FG1["Fxz"..CLi]:EnableMouse(true)
		ConsRS.FG1["Fxz"..CLi]:SetFrameStrata("LOW")
		ConsRS.FG1["Fxz"..CLi]:SetScale(0.9)
		ConsRS.FG1["Fxz"..CLi]:SetPoint("BOTTOM", ConsRS.FG1["Fx"..CLi], "TOP", 0, -3)
		ConsRS.FG1["Fxz"..CLi]:SetBackdrop( { 
			bgFile = "Interface\\Buttons\\WHITE8X8", tile = false, tileSize=0,
			edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
			tile = true, tileSize = 10, edgeSize = 10, insets = { left = 2, right = 2, top = 2, bottom = 2 }
		});
		ConsRS.FG1["Fxz"..CLi]:SetScript("OnMouseDown", function(self, button)
				if button == "LeftButton" then
					ConsRS.PosRaidFrames()
					ConsRS.FG1:StartMoving();
					ConsRS.FG1.isMoving = true;
				end
		end)
		ConsRS.FG1["Fxz"..CLi]:SetScript("OnMouseUp", function(self, button)
			if button == "LeftButton" and ConsRS.FG1.isMoving then
				ConsRS.PosRaidFrames()
				ConsRS.FG1:StopMovingOrSizing();
				ConsRS.FG1.isMoving = false;
			end
		end)
		ConsRS.FG1["Fxz"..CLi]:SetScript("OnHide", function(self)
			if ( ConsRS.FG1.isMoving ) then
				ConsRS.FG1:StopMovingOrSizing();
				ConsRS.FG1.isMoving = false;
			end
		end)
		ConsRS.FG1["Fxz"..CLi]:SetBackdropColor(0.5,0,0,1)
		ConsRS.FG1["Fxz"..CLi]["FS"] = ConsRS.FG1["Fxz"..CLi]:CreateFontString("ConsRS_Fx3x_FFG1S"..CLi,"ARTWORK", "ChatFontNormal")
		ConsRS.FG1["Fxz"..CLi]["FS"]:SetParent(ConsRS.FG1["Fxz"..CLi])
		ConsRS.FG1["Fxz"..CLi]["FS"]:SetPoint("LEFT",ConsRS.FG1["Fxz"..CLi],"LEFT",0,1)
		ConsRS.FG1["Fxz"..CLi]["FS"]:SetWidth(150)
		ConsRS.FG1["Fxz"..CLi]["FS"]:SetHeight(20)
		ConsRS.FG1["Fxz"..CLi]["FS"]:SetJustifyH("CENTER")
		ConsRS.FG1["Fxz"..CLi]["FS"]:SetFontObject("GameFontNormalLarge")
		ConsRS.FG1["Fxz"..CLi]["FS"]:SetText("Group "..CLi)



		
		
		for Cx = 1, 5 do
			ConsRS.FG1["Fx"..CLi][Cx] = CreateFrame("frame", "ConsRS_Frame_FF"..Cx, ConsRS.FG1["Fx"..CLi])
			ConsRS.FG1["Fx"..CLi][Cx]:SetWidth(150)
			ConsRS.FG1["Fx"..CLi][Cx]:SetHeight(25)
			ConsRS.FG1["Fx"..CLi][Cx]:SetMovable(true)
			ConsRS.FG1["Fx"..CLi][Cx]:SetScript("OnMouseUp", function(self, button)
				if button == "LeftButton" and self.isMoving then
					self:SetFrameStrata("LOW")
					self:StopMovingOrSizing();
					self.isMoving = false;
					ConsRS.HideClicks()
					
					local zderp = 0
					for CLx = 1, 8 do
						if (ConsRS.RaidFramePos["g1"][1]) then
							local zleft, zright, ztop, zbottom = self:GetLeft(), self:GetRight(), self:GetTop(), self:GetBottom()
							local znr1, znr2, znr3, znr4 = ConsRS.RaidFramePos["g"..CLx][1], ConsRS.RaidFramePos["g"..CLx][2], ConsRS.RaidFramePos["g"..CLx][3], ConsRS.RaidFramePos["g"..CLx][4]
							if (znr1 > zleft + ((zright - zleft)/2) or znr2 < zright - ((zright - zleft)/2) or znr3 < ztop + ((zbottom - ztop)/2) or znr4 > zbottom - ((zbottom - ztop)/2)) then
							else
								zderp = CLx
							end
						end
					end
					if (ConsRS.DubbleClickCD == 1) then
						ConsRS.DubbleClickCD = 0
						ConsRS.FG1["Fx"..CLi][Cx].editFrame:Show()
						ConsRS.FG1["Fx"..CLi][Cx].editFrame:SetFocus()
					elseif (zderp > 0) then
						if (zderp ~= CLi and ConsRS.RaidFramePos["g"..zderp]["FNr"] > 4) then
							


							local ztop, zbottom = self:GetTop(), self:GetBottom()
							for Cxx = 1, 5 do
								local znr1, znr2 = ConsRS.FG1["Fx"..zderp][Cxx]:GetTop(), ConsRS.FG1["Fx"..zderp][Cxx]:GetBottom()
								if (Cxx) then
									if (znr1 < ztop + ((zbottom - ztop)/2) or znr2 > zbottom - ((zbottom - ztop)/2)) then
									else
										ztext = self.FS:GetText()
										ztextto = ConsRS.FG1["Fx"..zderp][Cxx]["FS"]:GetText()
										if (ztextto == nil or ztextto == "") then
										else
											ConsRS.DragedToSameG(zderp, Cx, Cxx, ztext, ztextto, CLi)
										end
									end
								end
							end


							
							
						elseif (zderp == CLi) then
							local ztop, zbottom = self:GetTop(), self:GetBottom()
							for Cxx = 1, 5 do
								local znr1, znr2 = ConsRS.FG1["Fx"..CLi][Cxx]:GetTop(), ConsRS.FG1["Fx"..CLi][Cxx]:GetBottom()
								if (Cxx ~= Cx) then
									if (znr1 < ztop + ((zbottom - ztop)/2) or znr2 > zbottom - ((zbottom - ztop)/2)) then
									else
										ztext = self.FS:GetText()
										ztextto = ConsRS.FG1["Fx"..CLi][Cxx]["FS"]:GetText()
										if (ztextto == nil or ztextto == "") then
											local zClass = ConsRS.RaidFramePos["g"..zderp]["C"][Cx]
											ConsRS.RaidFramePos["g"..zderp]["F"][Cxx] = ConsRS.RaidFramePos["g"..zderp]["F"][Cx]
											ConsRS.RaidFramePos["g"..zderp]["C"][Cxx] = zClass
											ConsRS.FG1["Fx"..zderp][Cxx]:SetBackdropColor(ConsRS.ClassColors[zClass][1],ConsRS.ClassColors[zClass][2],ConsRS.ClassColors[zClass][3],1)
											ConsRS.FG1["Fx"..zderp][Cxx]:Show()
											ConsRS.FG1["Fx"..zderp][Cxx]["FS"]:SetText(ztext)
											self.FS:SetText("")
											ConsRS.RaidFramePos["g"..zderp]["F"][Cx] = 0
											ConsRS.RaidFramePos["g"..zderp]["C"][Cx] = 0
											ConsRS.FG1["Fx"..zderp][Cx]:Hide()
										else
											ConsRS.DragedToSameG(zderp, Cx, Cxx, ztext, ztextto)
										end
									end
								end
							end
						else
							ztext = self.FS:GetText()
							ConsRS.DragedToThis(zderp, ConsRS.RaidFramePos["g"..CLi]["C"][Cx], ztext)
							ConsRS.RaidFramePos["g"..CLi]["F"][Cx] = 0
							ConsRS.RaidFramePos["g"..CLi]["C"][Cx] = 0
							ConsRS.RaidFramePos["g"..CLi]["FNr"] = ConsRS.RaidFramePos["g"..CLi]["FNr"] - 1
							ConsRS.FG1["Fx"..CLi][Cx]["FS"]:SetText("")
							ConsRS.FG1["Fx"..CLi][Cx]:Hide()
						end
						local zswd = ConsRS.FG1["Fx"..CLi]:GetWidth()
						local zshd = ConsRS.FG1["Fx"..CLi]:GetHeight()
						self:ClearAllPoints()
						self:SetPoint("TOPLEFT", ConsRS.FG1["Fx"..CLi], "TOPLEFT",0,-((25*Cx)-25))
					else
						self:ClearAllPoints()
						self:SetPoint("TOPLEFT", ConsRS.FG1["Fx"..CLi], "TOPLEFT",0,-((25*Cx)-25))
						self.FS:SetText("")
						ConsRS.RaidFramePos["g"..CLi]["F"][Cx] = 0
						ConsRS.RaidFramePos["g"..CLi]["C"][Cx] = 0
						ConsRS.RaidFramePos["g"..CLi]["FNr"] = ConsRS.RaidFramePos["g"..CLi]["FNr"] - 1
						ConsRS.FG1["Fx"..CLi][Cx]:Hide()
					end
					ConsRSTimer3:Play()
					ConsRS.DubbleClickCD = 1
					ConsRS.AutoSaveRaid()
				end
			end)

			ConsRS.FG1["Fx"..CLi][Cx]:SetScript("OnMouseDown", function(self, button)
				if button == "LeftButton" and not self.isMoving then
					self:SetFrameStrata("HIGH")
					self:StartMoving();
					self.isMoving = true;
				end
			end)
			ConsRS.FG1["Fx"..CLi][Cx]:EnableMouse(true)
			ConsRS.FG1["Fx"..CLi][Cx]:SetPoint("TOPLEFT", ConsRS.FG1["Fx"..CLi], "TOPLEFT",0,-((25*Cx)-25))
			ConsRS.FG1["Fx"..CLi][Cx]:SetBackdrop( { 
				bgFile = "Interface\\Buttons\\WHITE8X8", tile = false, tileSize=0,
				edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
				tile = true, tileSize = 10, edgeSize = 10, insets = { left = 2, right = 2, top = 2, bottom = 2 }
			});
			ConsRS.FG1["Fx"..CLi][Cx]["FS"] = ConsRS.FG1["Fx"..CLi][Cx]:CreateFontString("ConsRS_Fx3_FFG1S"..CLi,"ARTWORK", "ChatFontNormal")
			ConsRS.FG1["Fx"..CLi][Cx]["FS"]:SetParent(ConsRS.FG1["Fx"..CLi][Cx])
			ConsRS.FG1["Fx"..CLi][Cx]["FS"]:SetPoint("LEFT",ConsRS.FG1["Fx"..CLi][Cx],"LEFT",0,0)
			ConsRS.FG1["Fx"..CLi][Cx]["FS"]:SetWidth(150)
			ConsRS.FG1["Fx"..CLi][Cx]["FS"]:SetHeight(20)
			ConsRS.FG1["Fx"..CLi][Cx]["FS"]:SetJustifyH("CENTER")
			ConsRS.FG1["Fx"..CLi][Cx]["FS"]:SetFontObject("GameFontNormal")
			ConsRS.FG1["Fx"..CLi][Cx]["FS"]:SetText("")

			ConsRS.FG1["Fx"..CLi][Cx].editFrame = CreateFrame("EditBox", nil, UIConfig, "InputBoxTemplate")
			ConsRS.FG1["Fx"..CLi][Cx].editFrame:SetPoint("LEFT",ConsRS.FG1["Fx"..CLi][Cx],"LEFT",30,0)
			ConsRS.FG1["Fx"..CLi][Cx].editFrame:SetParent(ConsRS.FG1["Fx"..CLi][Cx])
			ConsRS.FG1["Fx"..CLi][Cx].editFrame:SetWidth(100)
			ConsRS.FG1["Fx"..CLi][Cx].editFrame:SetHeight(25)
			ConsRS.FG1["Fx"..CLi][Cx].editFrame:SetMovable(false)
			ConsRS.FG1["Fx"..CLi][Cx].editFrame:SetAutoFocus(false)
			ConsRS.FG1["Fx"..CLi][Cx].editFrame:SetMaxLetters(32000)
			ConsRS.FG1["Fx"..CLi][Cx].editFrame:SetScript("OnEnterPressed", function(self)
				local ztext = ConsRS.FG1["Fx"..CLi][Cx].editFrame:GetText()
				ztext = string.lower(ztext)
				if (string.find(string.sub(ztext,1,1), "%a")) then
					ztext = string.upper(string.sub(ztext,1,1))..string.sub(ztext,2)
				end
				if (ztext ~= "" and ztext ~= nil) then
					ConsRS.FG1["Fx"..CLi][Cx]["FS"]:SetText(ztext)
				end
				ConsRS.FG1["Fx"..CLi][Cx].editFrame:ClearFocus()
				ConsRS.FG1["Fx"..CLi][Cx].editFrame:Hide()
				ConsRS.AutoSaveRaid()
			end)
			ConsRS.FG1["Fx"..CLi][Cx].editFrame:SetScript("OnEscapePressed", function(self)
				ConsRS.FG1["Fx"..CLi][Cx].editFrame:SetText("")
				ConsRS.FG1["Fx"..CLi][Cx].editFrame:ClearFocus()
				ConsRS.FG1["Fx"..CLi][Cx].editFrame:Hide()
			end)
			ConsRS.FG1["Fx"..CLi][Cx].editFrame:SetScript("OnEditFocusLost", function(self)
				ConsRS.FG1["Fx"..CLi][Cx].editFrame:Hide()
				ConsRS.FG1["Fx"..CLi][Cx].editFrame:SetText("")
			end)
			ConsRS.FG1["Fx"..CLi][Cx].editFrame:Hide()
			ConsRS.FG1["Fx"..CLi][Cx]:Hide()
			if (not ConsRS.RaidFramePos["g"..CLi]["F"]) then
				ConsRS.RaidFramePos["g"..CLi]["F"] = {}
			end
			if (not ConsRS.RaidFramePos["g"..CLi]["C"]) then
				ConsRS.RaidFramePos["g"..CLi]["C"] = {}
			end
			ConsRS.RaidFramePos["g"..CLi]["F"][Cx] = 0
			ConsRS.RaidFramePos["g"..CLi]["C"][Cx] = 0
			ConsRS.RaidFramePos["g"..CLi]["FNr"] = 0
		end
		
		
	end
end
function ConsRS.DragedToSameG(zgroup, FromSpot, ToSpot, ztext, ztextto, ExtraGroup)
	if (not ExtraGroup) then
		ExtraGroup = zgroup
	end
	local zclaz = ConsRS.RaidFramePos["g"..ExtraGroup]["C"][FromSpot]
	local zclaz2 = ConsRS.RaidFramePos["g"..zgroup]["C"][ToSpot]
	if (not zclaz2) then
		zclaz2 = 0
	end
	if (not zclaz) then
		zclaz = 0
	end
	ConsRS.RaidFramePos["g"..ExtraGroup]["C"][FromSpot] = zclaz2
	ConsRS.RaidFramePos["g"..zgroup]["C"][ToSpot] = zclaz
	if (ztextto) then
		ConsRS.FG1["Fx"..ExtraGroup][FromSpot]["FS"]:SetText(ztextto)
		ConsRS.FG1["Fx"..ExtraGroup][FromSpot]:SetBackdropColor(ConsRS.ClassColors[zclaz2][1],ConsRS.ClassColors[zclaz2][2],ConsRS.ClassColors[zclaz2][3],1)
		ConsRS.FG1["Fx"..ExtraGroup][FromSpot]:Show()
	elseif (ConsRS.FG1["Fx"..ExtraGroup][FromSpot] ~= 0) then
		ConsRS.FG1["Fx"..ExtraGroup][FromSpot]:Hide()
		ConsRS.FG1["Fx"..ExtraGroup][FromSpot]["FS"]:SetText("")
		ConsRS.RaidFramePos["g"..ExtraGroup]["C"][FromSpot] = 0
	end
	if (ztext and ConsRS.ClassColors[zclaz]) then
		ConsRS.FG1["Fx"..zgroup][ToSpot]["FS"]:SetText(ztext)
		ConsRS.FG1["Fx"..zgroup][ToSpot]:SetBackdropColor(ConsRS.ClassColors[zclaz][1],ConsRS.ClassColors[zclaz][2],ConsRS.ClassColors[zclaz][3],1)
		ConsRS.FG1["Fx"..zgroup][ToSpot]:Show()
	end
end
function ConsRS.DragedToThis(zgroup, zClass, ztext)
	if (ConsRS.RaidFramePos["g"..zgroup]["FNr"] > 4) then
		print("Error: group "..zgroup.." is Full!")
	else
		for CLx = 1, 5 do
			if (ConsRS.RaidFramePos["g"..zgroup]["F"][CLx] == 0) then
				ConsRS.RaidFramePos["g"..zgroup]["F"][CLx] = 1
				ConsRS.RaidFramePos["g"..zgroup]["C"][CLx] = zClass
				ConsRS.FG1["Fx"..zgroup][CLx]:SetBackdropColor(ConsRS.ClassColors[zClass][1],ConsRS.ClassColors[zClass][2],ConsRS.ClassColors[zClass][3],1)
				ConsRS.FG1["Fx"..zgroup][CLx]:Show()
				ConsRS.FG1["Fx"..zgroup][CLx]["FS"]:SetText(ztext)
				ConsRS.RaidFramePos["g"..zgroup]["FNr"] = ConsRS.RaidFramePos["g"..zgroup]["FNr"] + 1
				break
			end
		end
	end
end
function ConsRS.PosRaidFrames()
	for CLi = 1, 8 do
		ConsRS.Fx3.F[CLi]:ClearAllPoints()
		ConsRS.Fx3.F[CLi]:SetPoint("TOPLEFT", ConsRS.Fx3.F, "TOPLEFT",0,-((25*CLi)))
		for Cx = 1, 5 do
			ConsRS.FG1["Fx"..CLi][Cx]:ClearAllPoints()
			ConsRS.FG1["Fx"..CLi][Cx]:SetPoint("TOPLEFT", ConsRS.FG1["Fx"..CLi], "TOPLEFT",0,-((25*Cx)-25))
		end
	end
	for CLx = 1, 8 do
		ConsRS.RaidFramePos["g"..CLx][1] = ConsRS.FG1["Fx"..CLx]:GetLeft()
		ConsRS.RaidFramePos["g"..CLx][2] = ConsRS.FG1["Fx"..CLx]:GetRight()
		ConsRS.RaidFramePos["g"..CLx][3] = ConsRS.FG1["Fx"..CLx]:GetTop()
		ConsRS.RaidFramePos["g"..CLx][4] = ConsRS.FG1["Fx"..CLx]:GetBottom()
	end
end
function ConsRS.pairsByKeys (t, f)
    local a = {}
    for n in pairs(t) do table.insert(a, n) end
    table.sort(a, f)
    local i = 0
    local iter = function ()
        i = i + 1
        if a[i] == nil then return nil
        else return a[i], t[a[i]]
        end
     end
     return iter
end
function ConsRS.testMove()
	ConsRS.TimerACtive = 0
	ConsRS.ZeSortzRaid = nil
	ConsRS.ZeSortzRaid = {}
	ConsRS.InSaveRaid = nil
	ConsRS.InSaveRaid = {}
	ConsRS.IsInRaid = nil
	ConsRS.IsInRaid = {}
	ConsRS.ReplacementClasses = nil
	ConsRS.ReplacementClasses = {}
	ConsRS.WrongG = nil
	ConsRS.WrongG = {}
	ConsRS.RightG = nil
	ConsRS.RightG = {}
	ConsRS.Numbrs = nil
	ConsRS.Numbrs = {}
	for AAP_index,AAP_value in ConsRS.pairsByKeys(ConsRSVar1["SavedRaids"][ConsRS.RaidName]) do
		if (not ConsRS.ZeSortzRaid[AAP_index]) then
			ConsRS.ZeSortzRaid[AAP_index] = {}
		end
		for AAP_index2,AAP_value2 in ConsRS.pairsByKeys(ConsRSVar1["SavedRaids"][ConsRS.RaidName][AAP_index]) do
			ConsRS.ZeSortzRaid[AAP_index][AAP_index2] = AAP_value2
		end
	end
	for CLi = 1, 8 do
		if (not ConsRS.Numbrs[CLi]) then
			ConsRS.Numbrs[CLi] = 0
		end
		for Cx = 1, 5 do
			local Znm = ConsRS.ZeSortzRaid["g"..CLi]["p"..Cx]
			local Znm2 = ConsRS.ZeSortzRaid["g"..CLi]["c"..Cx]
			if (Znm and Znm ~= 0) then
				ConsRS.InSaveRaid[Znm] = Znm2
			end
		end
	end
	for CLi = 1, 40 do
		local ZeButton = getglobal("RaidGroupButton"..CLi)
		if (ZeButton.name) then
			ConsRS.IsInRaid[ZeButton.name] = CLi
			local point, relativeTo = ZeButton:GetPoint()
			local ZePFrame = relativeTo:GetName()
			local _,_,ZeGroup2, Zslot = string.find(ZePFrame, "RaidGroup(%d+)Slot(%d+)")
			ZeGroup = tonumber(ZeGroup2)
			ConsRS.Numbrs[ZeGroup] = ConsRS.Numbrs[ZeGroup] + 1
			if (not ConsRS.InSaveRaid[ZeButton.name]) then
				local RaidPos, ZeClass = ConsRS.GetRaidNumber(ZeButton.name)
				if (ZeClass == "Druid") then
					ZeClass = 1
				elseif (ZeClass == "Hunter") then
					ZeClass = 2
				elseif (ZeClass == "Mage") then
					ZeClass = 3
				elseif (ZeClass == "Paladin") then
					ZeClass = 4
				elseif (ZeClass == "Shaman") then
					ZeClass = 4
				elseif (ZeClass == "Priest") then
					ZeClass = 5
				elseif (ZeClass == "Rogue") then
					ZeClass = 6
				elseif (ZeClass == "Warlock") then
					ZeClass = 7
				elseif (ZeClass == "Warrior") then
					ZeClass = 8
				end
				if (not ConsRS.ReplacementClasses["c"..ZeClass]) then
					ConsRS.ReplacementClasses["c"..ZeClass] = {}
				end
				ConsRS.ReplacementClasses["c"..ZeClass][ZeButton.name] = ZeGroup
			end
		end
	end
	print("--- Checking Raid ---")
	for CLi = 1, 8 do
		for Cx = 1, 5 do
			local Znm = ConsRS.ZeSortzRaid["g"..CLi]["p"..Cx]
			local Znm2 = ConsRS.ZeSortzRaid["g"..CLi]["c"..Cx]
			if (Znm and Znm ~= 0) then
				if (ConsRS.IsInRaid[Znm]) then
				else
					if (ConsRS.ReplacementClasses["c"..Znm2]) then
						local replaceddf = 0
						for AAP_index2,AAP_value2 in ConsRS.pairsByKeys(ConsRS.ReplacementClasses["c"..Znm2]) do
							print("replaced: "..Znm.." with: "..AAP_index2)
							ConsRS.ZeSortzRaid["g"..CLi]["p"..Cx] = AAP_index2
							ConsRS.ReplacementClasses["c"..Znm2][AAP_index2] = nil
							replaceddf = 1
							break
						end
						if (replaceddf == 0) then
							ConsRS.ZeSortzRaid["g"..CLi]["p"..Cx] = 0
							ConsRS.ZeSortzRaid["g"..CLi]["c"..Cx] = 0
							print(Znm.." is missing (g"..CLi.."), found no replacement")
						end
					else
						ConsRS.ZeSortzRaid["g"..CLi]["p"..Cx] = 0
						ConsRS.ZeSortzRaid["g"..CLi]["c"..Cx] = 0
						print(Znm.." is missing (g"..CLi.."), found no replacement")
					end
				end
			elseif (Znm2 > 0) then
				if (ConsRS.ReplacementClasses["c"..Znm2]) then
					local replaceddf = 0
					for AAP_index2,AAP_value2 in ConsRS.pairsByKeys(ConsRS.ReplacementClasses["c"..Znm2]) do
						print("replaced: "..ConsRS.GetClassName(Znm2).." with: "..AAP_index2)
						ConsRS.ZeSortzRaid["g"..CLi]["p"..Cx] = AAP_index2
						ConsRS.ReplacementClasses["c"..Znm2][AAP_index2] = nil
						replaceddf = 1
						break
					end
					if (replaceddf == 0) then
						ConsRS.ZeSortzRaid["g"..CLi]["p"..Cx] = 0
						ConsRS.ZeSortzRaid["g"..CLi]["c"..Cx] = 0
						print(ConsRS.GetClassName(Znm2).." is missing (g"..CLi.."), found no replacement")
					end
				else
					ConsRS.ZeSortzRaid["g"..CLi]["p"..Cx] = 0
					ConsRS.ZeSortzRaid["g"..CLi]["c"..Cx] = 0
					print(ConsRS.GetClassName(Znm2).." is missing (g"..CLi.."), found no replacement")
				end
			end
		end
	end
	ConsRS.InSaveRaid = nil
	ConsRS.InSaveRaid = {}
	for CLi = 1, 8 do
		ConsRS.WrongG[CLi] = {}
		for Cx = 1, 5 do
			local Znm = ConsRS.ZeSortzRaid["g"..CLi]["p"..Cx]
			local Znm2 = ConsRS.ZeSortzRaid["g"..CLi]["c"..Cx]
			if (Znm and Znm ~= 0) then
				ConsRS.InSaveRaid[Znm] = Znm2
			end
		end
	end
	print("--- Sorting Raid ---")
	ConsRS.Frame32:Show()
	ConsRS.Frame32.FS2:SetText("0/"..GetNumGroupMembers())
	for CLi2 = 1, 8 do
		for Cx = 1, 5 do
			local TargetName = ConsRS.ZeSortzRaid["g"..CLi2]["p"..Cx]
			if (ConsRS.InSaveRaid[TargetName]) then
				local ZeGroup, Zds
				for CLi = 1, 40 do
					local ZeButton = getglobal("RaidGroupButton"..CLi)
					if (ZeButton.name == TargetName) then
						local point, relativeTo = ZeButton:GetPoint()
						local ZePFrame = relativeTo:GetName()
						local _,_,ZeGroup2, Zslot = string.find(ZePFrame, "RaidGroup(%d+)Slot(%d+)")
						ZeGroup = tonumber(ZeGroup2)
						Zds = CLi
						break
					end
				end
				if (ZeGroup and CLi2 ~= ZeGroup) then
					ConsRS.WrongG[ZeGroup][TargetName] = CLi2
				elseif (ZeGroup) then
					ConsRS.RightG[TargetName] = CLi2
				end
			else
			end
		end
	end
	ConsRSTimer2:Play()
	ConsRS.testMove2()
end
function ConsRS.GetClassName(DeClass)
	local ZeDsl = 0
	if (DeClass == 1) then
		ZeDsl = "Druid"
	elseif (DeClass == 2) then
		ZeDsl = "Hunter"
	elseif (DeClass == 3) then
		ZeDsl = "Mage"
	elseif (DeClass == 4) then
		if (ConsRS.Faction == "Horde") then
			ZeDsl = "Shaman"
		else
			ZeDsl = "Paladin"
		end
	elseif (DeClass == 5) then
		ZeDsl = "Priest"
	elseif (DeClass == 6) then
		ZeDsl = "Rogue"
	elseif (DeClass == 7) then
		ZeDsl = "Warlock"
	elseif (DeClass == 8) then
		ZeDsl = "Warrior"
	end
	return ZeDsl
end
function ConsRS.GetRaidNumber(Zname)
	for CLi = 1, 40 do
		local name, _, subgroup, _, class = GetRaidRosterInfo(CLi)
		if (name == Zname) then
			return CLi, class, subgroup
		end
	end
end
function ConsRS.testMove2()
	--if (ConsRS.TimerACtive == 0) then
	--	return
	--end
	ConsRS.TimerACtive = 1
	ConsRS.WrongG = nil
	ConsRS.WrongG = {}
	ConsRS.RightG = nil
	ConsRS.RightG = {}
	ConsRS.Numbrs = nil
	ConsRS.Numbrs = {}
	for CLi2 = 1, 8 do
		ConsRS.Numbrs[CLi2] = 0
		ConsRS.WrongG[CLi2] = {}
	end
	for CLi = 1, 40 do
		local ZeButton = getglobal("RaidGroupButton"..CLi)
		if (ZeButton.name) then
			ConsRS.IsInRaid[ZeButton.name] = CLi
			local point, relativeTo = ZeButton:GetPoint()
			local ZePFrame = relativeTo:GetName()
			local _,_,ZeGroup2, Zslot = string.find(ZePFrame, "RaidGroup(%d+)Slot(%d+)")
			ZeGroup = tonumber(ZeGroup2)
			ConsRS.Numbrs[ZeGroup] = ConsRS.Numbrs[ZeGroup] + 1
		end
	end
	for CLi2 = 1, 8 do
		for Cx = 1, 5 do
			local TargetName = ConsRS.ZeSortzRaid["g"..CLi2]["p"..Cx]
			if (TargetName) then
				local _, _, ZeGroup = ConsRS.GetRaidNumber(TargetName)
				if (ZeGroup and CLi2 ~= ZeGroup) then
					ConsRS.WrongG[ZeGroup][TargetName] = CLi2
				elseif (ZeGroup) then
					ConsRS.RightG[TargetName] = CLi2
				end
			end
		end
	end
	local DoinAMove = 0
	for CLi2 = 1, 8 do
		if (DoinAMove == 1) then
			break
		end
		for Cx = 1, 5 do
			if (DoinAMove == 1) then
				break
			end
			local zeNbr = ((CLi2*5)-5)+Cx
			local TargetName = ConsRS.ZeSortzRaid["g"..CLi2]["p"..Cx]
			if (TargetName and not ConsRS.RightG[TargetName] and TargetName ~= 0) then
				local Spotz, zClass, zGroup = ConsRS.GetRaidNumber(TargetName)
				local destG = ConsRS.WrongG[zGroup][TargetName]
				local LetTrhu
				for AAP_index,AAP_value in ConsRS.pairsByKeys(ConsRS.WrongG[destG]) do
					if (AAP_value == zGroup) then
						LetTrhu = AAP_index
						break
					end
				end
				if (LetTrhu) then
					DoinAMove = 1
					local p1 = ConsRS.GetRaidNumber(TargetName)
					local p2 = ConsRS.GetRaidNumber(LetTrhu)
					--print("Changed Spot: "..TargetName,LetTrhu)
					ConsRS.Frame32.FS2:SetText(zeNbr.."/"..GetNumGroupMembers())
					SwapRaidSubgroup(p1, p2)
				elseif (ConsRS.Numbrs[destG] < 5) then
					--print("Group not full moving: "..TargetName)
					DoinAMove = 1
					local p1 = ConsRS.GetRaidNumber(TargetName)
					--print("Moved: "..TargetName.." to group: "..destG)
					ConsRS.Frame32.FS2:SetText(zeNbr.."/"..GetNumGroupMembers())
					SetRaidSubgroup(p1, destG)
				else
					local LetTrhu2
					for AAP_index,AAP_value in ConsRS.pairsByKeys(ConsRS.WrongG[destG]) do
						LetTrhu2 = AAP_index
						break
					end
					if (LetTrhu2) then
						DoinAMove = 1
						local p1 = ConsRS.GetRaidNumber(TargetName)
						local p2 = ConsRS.GetRaidNumber(LetTrhu2)
						--print("Changed Spot: "..TargetName,LetTrhu2)
						ConsRS.Frame32.FS2:SetText(zeNbr.."/"..GetNumGroupMembers())
						SwapRaidSubgroup(p1, p2)
					else
						print("Can't move "..TargetName.."to group "..destG)
					end
				end
			end
		end
	end
	if (DoinAMove == 0) then
		print("--- Sorting Done! ---")
		ConsRSTimer4:Stop()
		ConsRSTimer4:Play()
		ConsRS.Frame32.FS2:SetText("Sorting Done!")
		ConsRS.TimerACtive = 0
		ConsRSTimer2:Stop()
	else
		ConsRSTimer:Play()
	end
end



function ConsRS.testMove22()
	ConsRS.Numbrs = nil
	ConsRS.Numbrs = {}
	for CLi2 = 1, 8 do
		ConsRS.Numbrs[CLi2] = 0
	end
	for CLi = 1, 40 do
		local ZeButton = getglobal("RaidGroupButton"..CLi)
		if (ZeButton.name) then
			ConsRS.IsInRaid[ZeButton.name] = CLi
			local point, relativeTo = ZeButton:GetPoint()
			local ZePFrame = relativeTo:GetName()
			local _,_,ZeGroup2, Zslot = string.find(ZePFrame, "RaidGroup(%d+)Slot(%d+)")
			ZeGroup = tonumber(ZeGroup2)
			ConsRS.Numbrs[ZeGroup] = ConsRS.Numbrs[ZeGroup] + 1
		end
	end
	local ToMove, MoveWith, Empty, Replacemenz, ReplacemenzMissing
	for CLi2 = 1, 8 do
		if (MoveWith or Empty or Replacemenz) then
			break
		end
		for Cx = 1, 5 do
			if (MoveWith or Empty or Replacemenz) then
				break
			end
			local TargetName = ConsRS.ZeSortzRaid["g"..CLi2]["p"..Cx]
			if (not ConsRS.RightG[TargetName]) then
				ToMove = TargetName
				if (ConsRS.InSaveRaid[TargetName]) then
					local ZeGroup, Zds
					for CLi = 1, 40 do
						local ZeButton = getglobal("RaidGroupButton"..CLi)
						if (ZeButton.name == TargetName) then
							local point, relativeTo = ZeButton:GetPoint()
							local ZePFrame = relativeTo:GetName()
							local _,_,ZeGroup2, Zslot = string.find(ZePFrame, "RaidGroup(%d+)Slot(%d+)")
							ZeGroup = tonumber(ZeGroup2)
							Zds = CLi
							break
						end
					end
					if (CLi2 ~= ZeGroup) then
						for AAP_index,AAP_value in pairs(ConsRS.WrongG[CLi2]) do
							if (AAP_value == ZeGroup) then
								print("Found Matching Replacement: "..AAP_index)
								MoveWith = AAP_index
								break
							end
						end
						if (not MoveWith) then
							if (ConsRS.Numbrs[CLi2] < 5) then
								Empty = CLi2
							else
								for CLi = 1, 5 do
								--ConsRS.InSaveRaid
								end
								for CLix = 1, 40 do
									local ZeButtonx = getglobal("RaidGroupButton"..CLix)
									if (ZeButtonx.name) then
										local point, relativeTo = ZeButtonx:GetPoint()
										local ZePFrame = relativeTo:GetName()
										local _,_,ZeGroup2, Zslot = string.find(ZePFrame, "RaidGroup(%d+)Slot(%d+)")
										ZeGroupx = tonumber(ZeGroup2)
										if (CLi2 == ZeGroupx) then
											if (not ConsRS.InSaveRaid[ZeButtonx.name]) then
												MoveWith = ZeButtonx.name
												break
											end
										end
									end
								end
								if (not MoveWith) then
									print(TargetName.." is NOT in the right group")
								end
							end
						end
					else
					end
				else

				end
			else
				--print(TargetName.." is in the right group!!")
			end
		end
	end
	if (MoveWith) then
		local p1 = ConsRS.GetRaidNumber(ToMove)
		local p2 = ConsRS.GetRaidNumber(MoveWith)
		print("Changed Spot: "..ToMove,MoveWith)
		SwapRaidSubgroup(p1, p2)
	elseif (Empty) then
		local p1 = ConsRS.GetRaidNumber(ToMove)
		print("Moved: "..ToMove.." to group: "..Empty)
		SetRaidSubgroup(p1, Empty)
	elseif (Replacemenz) then
		local ZeGroup = ConsRS.Missing[ReplacemenzMissing]
		if (ConsRS.Numbrs[ZeGroup] < 5) then
			local p1 = ConsRS.GetRaidNumber(Replacemenz)
			print("Moved: "..Replacemenz.." Replacement for: "..ReplacemenzMissing.." to group: "..ZeGroup)
			SetRaidSubgroup(p1, ZeGroup)
		else
			print("Derp")
		end

	else
		ConsRS.TimerACtive = 0
		print("--- Sorting Done! ---")
	end
	ToMove = nil
	Empty = nil
	MoveWith = nil
	ReplacemenzMissing = nil
	Replacemenz = nil

end

function ConsRS.SaveRaid(ZeRaidName)
	ConsRSVar1["SavedRaids"][ZeRaidName] = {}
	for CLi = 1, 8 do
		ConsRSVar1["SavedRaids"][ZeRaidName]["g"..CLi] = {}
		for Cx = 1, 5 do
			ZeClass = 0
			ZeName = 0
			ConsRSVar1["SavedRaids"][ZeRaidName]["g"..CLi]["c"..Cx] = ZeClass
			ConsRSVar1["SavedRaids"][ZeRaidName]["g"..CLi]["p"..Cx] = ZeName
		end
	end
	for CLi = 1, 40 do
		local ZeButton = getglobal("RaidGroupButton"..CLi)
		if (ZeButton.name) then
			local point, relativeTo = ZeButton:GetPoint()
			local ZePFrame = relativeTo:GetName()
			local _,_,ZGroup, Zslot = string.find(ZePFrame, "RaidGroup(%d+)Slot(%d+)")
			local RaidPos, ZeClass = ConsRS.GetRaidNumber(ZeButton.name)
			if (ZeClass == "Druid") then
				ZeClass = 1
			elseif (ZeClass == "Hunter") then
				ZeClass = 2
			elseif (ZeClass == "Mage") then
				ZeClass = 3
			elseif (ZeClass == "Paladin") then
				ZeClass = 4
			elseif (ZeClass == "Shaman") then
				ZeClass = 4
			elseif (ZeClass == "Priest") then
				ZeClass = 5
			elseif (ZeClass == "Rogue") then
				ZeClass = 6
			elseif (ZeClass == "Warlock") then
				ZeClass = 7
			elseif (ZeClass == "Warrior") then
				ZeClass = 8
			end
			ConsRSVar1["SavedRaids"][ZeRaidName]["g"..ZGroup]["c"..Zslot] = ZeClass
			ConsRSVar1["SavedRaids"][ZeRaidName]["g"..ZGroup]["p"..Zslot] = ZeButton.name
		end
	end
end
function ConsRS.ShowDelete()
	if (ConsRS.DeleteShow == 0) then
		local derps = 0
		for AAP_index,AAP_value in pairs(ConsRSVar1["SavedRaids"]) do
			derps = derps + 1
			if (ConsRS.Frame.F[derps].A) then
				ConsRS.Frame.F[derps].A:Show()
			end
		end
		ConsRS.DeleteShow = 1
	else
		local derps = 0
		for AAP_index,AAP_value in pairs(ConsRSVar1["SavedRaids"]) do
			derps = derps + 1
			if (ConsRS.Frame.F[derps].A) then
				ConsRS.Frame.F[derps].A:Hide()
			end
		end
		ConsRS.DeleteShow = 0
	end
end
function ConsRS.ListLines()
	ConsRS.FrameCounter = 0
	for CLi = 1, 40 do
		if (ConsRS.Frame.F[CLi]) then
			ConsRS.Frame.F[CLi]:Hide()
		end
	end
	for AAP_index,AAP_value in pairs(ConsRSVar1["SavedRaids"]) do
		ConsRS.MakeLine(AAP_index)
	end
end
function ConsRS.MakeLine(ZeText)
	ConsRS.FrameCounter = ConsRS.FrameCounter + 1
	local CLi = ConsRS.FrameCounter
	if (not ConsRS.Frame.F[CLi]) then
		ConsRS.Frame.F[CLi] = CreateFrame("frame", "ConsRS_Frame_FF"..CLi, ConsRS.Frame.F)
		ConsRS.Frame.F[CLi]:SetWidth(150)
		ConsRS.Frame.F[CLi]:SetHeight(25)
		ConsRS.Frame.F[CLi]:SetPoint("BOTTOMLEFT", ConsRS.Frame.F, "BOTTOMLEFT",0,-((25*CLi)))
		ConsRS.Frame.F[CLi]:SetBackdrop( { 
			bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", 
			edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
			tile = true, tileSize = 10, edgeSize = 10, insets = { left = 2, right = 2, top = 2, bottom = 2 }
		});
		ConsRS.Frame.F[CLi]:SetScript("OnMouseDown", function(self, button)
			if button == "RightButton" then
				ConsRS.Frame:StartMoving();
				ConsRS.Frame.isMoving = true;
			else
				ConsRS.Frame4.FS2:SetText(ConsRS.Frame.F[CLi].FS1:GetText())
				ConsRS.SelectedRaid = ConsRS.Frame.F[CLi].FS1:GetText()
				ConsRS.Frame4:Show()
				ConsRS.Fx3:Hide()
				ConsRS.FG1:Hide()
			end
		end)
		ConsRS.Frame.F[CLi]:SetScript("OnMouseUp", function(self, button)
			if button == "RightButton" and ConsRS.Frame.isMoving then
				ConsRS.Frame:StopMovingOrSizing();
				ConsRS.Frame.isMoving = false;
				ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["left"] = ConsRS.Frame:GetLeft()
				ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["top"] = ConsRS.Frame:GetTop() - GetScreenHeight()
				ConsRS.Frame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["left"], ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["top"])
			end
		end)
		ConsRS.Frame.F[CLi]:SetScript("OnHide", function(self)
			if ( ConsRS.Frame.isMoving ) then
				ConsRS.Frame:StopMovingOrSizing();
				ConsRS.Frame.isMoving = false;
				ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["left"] = ConsRS.Frame:GetLeft()
				ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["top"] = ConsRS.Frame:GetTop() - GetScreenHeight()
				ConsRS.Frame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["left"], ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["top"])
			end
		end)
		ConsRS.Frame.F[CLi].FS1 = ConsRS.Frame.F[CLi]:CreateFontString("ConsRS_Frame_FFS"..CLi,"ARTWORK", "ChatFontNormal")
		ConsRS.Frame.F[CLi].FS1:SetParent(ConsRS.Frame.F[CLi])
		ConsRS.Frame.F[CLi].FS1:SetPoint("LEFT",ConsRS.Frame.F[CLi],"LEFT",5,0)
		ConsRS.Frame.F[CLi].FS1:SetWidth(300)
		ConsRS.Frame.F[CLi].FS1:SetHeight(38)
		ConsRS.Frame.F[CLi].FS1:SetJustifyH("LEFT")
		ConsRS.Frame.F[CLi].FS1:SetFontObject("GameFontNormalLarge")
		ConsRS.Frame.F[CLi].FS1:SetText(ZeText)
		ConsRS.Frame.F[CLi].FS1:SetTextColor(0, 1, 0)


		ConsRS.Frame.F[CLi].A = CreateFrame("frame", "ConsRS_Frame_F2F"..CLi, ConsRS.Frame.F[CLi])
		ConsRS.Frame.F[CLi].A:SetWidth(65)
		ConsRS.Frame.F[CLi].A:SetHeight(25)
		ConsRS.Frame.F[CLi].A:Hide()
		ConsRS.Frame.F[CLi].A:SetPoint("TOPLEFT", ConsRS.Frame.F[CLi], "TOPRIGHT",0,0)
		ConsRS.Frame.F[CLi].A:SetBackdrop( { 
			bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", 
			edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
			tile = true, tileSize = 10, edgeSize = 10, insets = { left = 2, right = 2, top = 2, bottom = 2 }
		});
		ConsRS.Frame.F[CLi].A:SetScript("OnMouseDown", function(self, button)
			if button == "RightButton" then
				ConsRS.Frame:StartMoving();
				ConsRS.Frame.isMoving = true;
			else
				ConsRSVar1["SavedRaids"][ConsRS.Frame.F[CLi].FS1:GetText()] = nil
				ConsRS.ListLines()
			end
		end)
		ConsRS.Frame.F[CLi].A:SetScript("OnMouseUp", function(self, button)
			if button == "RightButton" and ConsRS.Frame.isMoving then
				ConsRS.Frame:StopMovingOrSizing();
				ConsRS.Frame.isMoving = false;
				ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["left"] = ConsRS.Frame:GetLeft()
				ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["top"] = ConsRS.Frame:GetTop() - GetScreenHeight()
				ConsRS.Frame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["left"], ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["top"])
			end
		end)
		ConsRS.Frame.F[CLi].A:SetScript("OnHide", function(self)
			if ( ConsRS.Frame.isMoving ) then
				ConsRS.Frame:StopMovingOrSizing();
				ConsRS.Frame.isMoving = false;
				ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["left"] = ConsRS.Frame:GetLeft()
				ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["top"] = ConsRS.Frame:GetTop() - GetScreenHeight()
				ConsRS.Frame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["left"], ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["top"])
			end
		end)
		ConsRS.Frame.F[CLi].A.FS1 = ConsRS.Frame.F[CLi]:CreateFontString("ConsRS_Frame_FF2S"..CLi,"ARTWORK", "ChatFontNormal")
		ConsRS.Frame.F[CLi].A.FS1:SetParent(ConsRS.Frame.F[CLi].A)
		ConsRS.Frame.F[CLi].A.FS1:SetPoint("LEFT",ConsRS.Frame.F[CLi].A,"LEFT",0,0)
		ConsRS.Frame.F[CLi].A.FS1:SetWidth(65)
		ConsRS.Frame.F[CLi].A.FS1:SetHeight(38)
		ConsRS.Frame.F[CLi].A.FS1:SetJustifyH("CENTER")
		ConsRS.Frame.F[CLi].A.FS1:SetFontObject("GameFontNormalLarge")
		ConsRS.Frame.F[CLi].A.FS1:SetText("Delete")
		ConsRS.Frame.F[CLi].A.FS1:SetTextColor(1, 0, 0)
		ConsRS.Frame.F[CLi]:Show()
	else
		ConsRS.Frame.F[CLi].FS1:SetText(ZeText)
		ConsRS.Frame.F[CLi].A:Hide()
		ConsRS.Frame.F[CLi]:Show()
	end
	ConsRS.DeleteShow = 0
end
function ConsRS.MakeRaidTemplate(ZeRaidName)
	ConsRSVar1["SavedRaids"][ZeRaidName] = {}
	for CLi = 1, 8 do
		ConsRSVar1["SavedRaids"][ZeRaidName]["g"..CLi] = {}
		for Cx = 1, 5 do
			ConsRSVar1["SavedRaids"][ZeRaidName]["g"..CLi]["p"..Cx] = 0
			ConsRSVar1["SavedRaids"][ZeRaidName]["g"..CLi]["c"..Cx] = 0
		end
	end
end
function ConsRS.LoadRaid()
	local ZeRaidName = ConsRS.SelectedRaid
	for CLi = 1, 8 do
		ConsRS.RaidFramePos["g"..CLi]["FNr"] = 0
	end
	for CLi = 1, 8 do
		for Cx = 1, 5 do
			local zClass = ConsRSVar1["SavedRaids"][ZeRaidName]["g"..CLi]["c"..Cx]
			if (zClass == 0) then
				ConsRS.RaidFramePos["g"..CLi]["F"][Cx] = 0
				ConsRS.RaidFramePos["g"..CLi]["C"][Cx] = 0
				ConsRS.FG1["Fx"..CLi][Cx]["FS"]:SetText("")
				ConsRS.FG1["Fx"..CLi][Cx]:Hide()
			else
				ConsRS.RaidFramePos["g"..CLi]["F"][Cx] = 1
				ConsRS.RaidFramePos["g"..CLi]["C"][Cx] = zClass
				ConsRS.FG1["Fx"..CLi][Cx]:SetBackdropColor(ConsRS.ClassColors[zClass][1],ConsRS.ClassColors[zClass][2],ConsRS.ClassColors[zClass][3],1)
				if (ConsRSVar1["SavedRaids"][ZeRaidName]["g"..CLi]["p"..Cx] ~= 0) then
					ConsRS.FG1["Fx"..CLi][Cx]["FS"]:SetText(ConsRSVar1["SavedRaids"][ZeRaidName]["g"..CLi]["p"..Cx])
				else
					if (zClass == 1) then
						ConsRS.FG1["Fx"..CLi][Cx]["FS"]:SetText("Druid")
						ConsRS.FG1["Fx"..CLi][Cx]["FS"]:SetTextColor(1, 1, 0)
					elseif (zClass == 2) then
						ConsRS.FG1["Fx"..CLi][Cx]["FS"]:SetText("Hunter")
						ConsRS.FG1["Fx"..CLi][Cx]["FS"]:SetTextColor(1, 1, 0)
					elseif (zClass == 3) then
						ConsRS.FG1["Fx"..CLi][Cx]["FS"]:SetText("Mage")
						ConsRS.FG1["Fx"..CLi][Cx]["FS"]:SetTextColor(1, 1, 0)
					elseif (zClass == 4) then
						if (ConsRS.Faction == "Horde") then
							ConsRS.FG1["Fx"..CLi][Cx]["FS"]:SetText("Shaman")
							ConsRS.FG1["Fx"..CLi][Cx]["FS"]:SetTextColor(1, 1, 0)
						else
							ConsRS.FG1["Fx"..CLi][Cx]["FS"]:SetText("Paladin")
							ConsRS.FG1["Fx"..CLi][Cx]["FS"]:SetTextColor(1, 1, 0)
						end
					elseif (zClass == 5) then
						ConsRS.FG1["Fx"..CLi][Cx]["FS"]:SetText("Priest")
						ConsRS.FG1["Fx"..CLi][Cx]["FS"]:SetTextColor(1, 1, 0)
					elseif (zClass == 6) then
						ConsRS.FG1["Fx"..CLi][Cx]["FS"]:SetText("Rogue")
						ConsRS.FG1["Fx"..CLi][Cx]["FS"]:SetTextColor(1, 1, 0)
					elseif (zClass == 7) then
						ConsRS.FG1["Fx"..CLi][Cx]["FS"]:SetText("Warlock")
						ConsRS.FG1["Fx"..CLi][Cx]["FS"]:SetTextColor(1, 1, 0)
					elseif (zClass == 8) then
						ConsRS.FG1["Fx"..CLi][Cx]["FS"]:SetText("Warrior")
						ConsRS.FG1["Fx"..CLi][Cx]["FS"]:SetTextColor(1, 1, 0)
					end
				end
				ConsRS.FG1["Fx"..CLi][Cx]:Show()
				ConsRS.RaidFramePos["g"..CLi]["FNr"] = ConsRS.RaidFramePos["g"..CLi]["FNr"] + 1
			end
		end
	end
end
function ConsRS.HideClicks()
	for CLi = 1, 8 do
		for Cx = 1, 5 do
			ConsRS.FG1["Fx"..CLi][Cx].editFrame:SetText("")
			ConsRS.FG1["Fx"..CLi][Cx].editFrame:ClearFocus()
			ConsRS.FG1["Fx"..CLi][Cx].editFrame:Hide()
		end
	end
end

function ConsRS.AutoSaveRaid()
	local ZeRaidName = ConsRS.SelectedRaid
	for CLi = 1, 8 do
		for Cx = 1, 5 do
			ConsRSVar1["SavedRaids"][ZeRaidName]["g"..CLi]["c"..Cx] = ConsRS.RaidFramePos["g"..CLi]["C"][Cx]
			local ZeName = ConsRS.FG1["Fx"..CLi][Cx]["FS"]:GetText()
			if (ZeName == "Druid") then
				ConsRSVar1["SavedRaids"][ZeRaidName]["g"..CLi]["p"..Cx] = 0
			elseif (ZeName == "Hunter") then
				ConsRSVar1["SavedRaids"][ZeRaidName]["g"..CLi]["p"..Cx] = 0
			elseif (ZeName == "Mage") then
				ConsRSVar1["SavedRaids"][ZeRaidName]["g"..CLi]["p"..Cx] = 0
			elseif (ZeName == "Paladin") then
				ConsRSVar1["SavedRaids"][ZeRaidName]["g"..CLi]["p"..Cx] = 0
			elseif (ZeName == "Shaman") then
				ConsRSVar1["SavedRaids"][ZeRaidName]["g"..CLi]["p"..Cx] = 0
			elseif (ZeName == "Priest") then
				ConsRSVar1["SavedRaids"][ZeRaidName]["g"..CLi]["p"..Cx] = 0
			elseif (ZeName == "Rogue") then
				ConsRSVar1["SavedRaids"][ZeRaidName]["g"..CLi]["p"..Cx] = 0
			elseif (ZeName == "Warlock") then
				ConsRSVar1["SavedRaids"][ZeRaidName]["g"..CLi]["p"..Cx] = 0
			elseif (ZeName == "Warrior") then
				ConsRSVar1["SavedRaids"][ZeRaidName]["g"..CLi]["p"..Cx] = 0
			else
				ConsRSVar1["SavedRaids"][ZeRaidName]["g"..CLi]["p"..Cx] = ZeName
			end
		end
	end
end
--SwapRaidSubgroup(fromNr, ToNr)
function ConsRS_SlashCmd()
	if (ConsRS.Frame.F:IsShown()) then
		ConsRS.Frame.F:Hide()
		ConsRS.Frame:Hide()
	else
		ConsRS.Frame:Show()
		ConsRS.Frame.F:Show()
	end
	ConsRS.Fx3:Hide()
	ConsRS.FG1:Hide()
end

ConsRSeventFrame = CreateFrame("Frame")
ConsRSeventFrame:RegisterEvent ("ADDON_LOADED")
ConsRSeventFrame:RegisterEvent ("GROUP_ROSTER_UPDATE")

ConsRSeventFrame:SetScript("OnEvent", function(self, event, ...)
	if (event=="ADDON_LOADED") then
		local arg1, arg2, arg3, arg4, arg5 = ...;
		if (arg1 == "Consequence-RaidSorter") then
			if (not ConsRSVar1) then
				ConsRSVar1 = {}
			end
			if (not ConsRSVar1["Raids"]) then
				ConsRSVar1["Raids"] = {}
			end
			if (not ConsRSVar1["SavedRaids"]) then
				ConsRSVar1["SavedRaids"] = {}
			end
			if (not ConsRSVar1["Raids"]["Tanks"]) then
				ConsRSVar1["Raids"]["Tanks"] = {}
			end
			if (not ConsRSVar1["Raids"]["Dps"]) then
				ConsRSVar1["Raids"]["Dps"] = {}
			end
			if (not ConsRSVar1["Raids"]["Healers"]) then
				ConsRSVar1["Raids"]["Healers"] = {}
			end
			if (not ConsRSVar1["Raids"]["Class"]) then
				ConsRSVar1["Raids"]["Class"] = {}
			end
			if (not ConsRSVar1[ConsRS.Realm]) then
				ConsRSVar1[ConsRS.Realm] = {}
			end
			if (not ConsRSVar1[ConsRS.Realm][ConsRS.Name]) then
				ConsRSVar1[ConsRS.Realm][ConsRS.Name] = {}
			end
			if (not ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]) then
				ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"] = {}
			end
			ConsRS.MakeFrames()
			if (ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["top"]) then
				ConsRS.Frame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["left"], ConsRSVar1[ConsRS.Realm][ConsRS.Name]["Settings"]["top"])
			end
			ConsRSTimer = ConsRSeventFrame:CreateAnimationGroup()
			ConsRSTimer.anim = ConsRSTimer:CreateAnimation()
			ConsRSTimer.anim:SetDuration(1.5)
			ConsRSTimer:SetLooping("REPEAT")
			ConsRSTimer:SetScript("OnLoop", function(self, event, ...)
				--ConsRS.MoveRaidOrder()
				ConsRS.testMove2()
				ConsRS.TimerACtive = 0
				ConsRSTimer:Stop()
			end)
			ConsRSTimer2 = ConsRSeventFrame:CreateAnimationGroup()
			ConsRSTimer2.anim = ConsRSTimer2:CreateAnimation()
			ConsRSTimer2.anim:SetDuration(4)
			ConsRSTimer2:SetLooping("REPEAT")
			ConsRSTimer2:SetScript("OnLoop", function(self, event, ...)
				ConsRS.testMove2()
			end)
			ConsRSTimer3 = ConsRSeventFrame:CreateAnimationGroup()
			ConsRSTimer3.anim = ConsRSTimer3:CreateAnimation()
			ConsRSTimer3.anim:SetDuration(0.4)
			ConsRSTimer3:SetLooping("REPEAT")
			ConsRSTimer3:SetScript("OnLoop", function(self, event, ...)
				ConsRS.DubbleClickCD = 0
				ConsRSTimer3:Stop()
			end)
			ConsRSTimer4 = ConsRSeventFrame:CreateAnimationGroup()
			ConsRSTimer4.anim = ConsRSTimer4:CreateAnimation()
			ConsRSTimer4.anim:SetDuration(0.1)
			ConsRSTimer4:SetLooping("REPEAT")
			ConsRSTimer4:SetScript("OnLoop", function(self, event, ...)
				if (ConsRS.AlphaFadeOut > 0) then
					ConsRS.AlphaFadeOut = ConsRS.AlphaFadeOut - 0.05
					ConsRS.Frame32:SetAlpha(ConsRS.AlphaFadeOut)
				else
					ConsRS.Frame32:Hide()
					ConsRS.Frame32:SetAlpha(1)
					ConsRS.AlphaFadeOut = 1
					ConsRSTimer4:Stop()
				end
			end)
			ConsRS.ListLines()
			SlashCmdList["ConsRS_Cmd"] = ConsRS_SlashCmd
			SLASH_ConsRS_Cmd1 = "/csort"
		end
	elseif (event=="GROUP_ROSTER_UPDATE") then
		if (ConsRS.TimerACtive == 1) then
			ConsRS.TimerACtive = 0
			ConsRSTimer:Play()
			ConsRS.testMove2()
		end
	end
end)
